unit cMagImport;

{
   Package: MAG - VistA Imaging
 WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
 Date Created:
 Site Name: Silver Spring, OIFO
 Developers: Garrett Kirin
        [==
 Description: Imaging Import API Delphi component

        ==]
 Note:
  }

interface

uses
inifiles, // 121 debug
Windows,
SysUtils,
Classes,
//va
Trpcb,
//imaging
cMagSecurity,
cMagUtils,
cMagDBBroker,
StdCtrls  ,
extctrls
, MaggMsgu
//121
, cmagigmanager
  ,  GearCORELib_TLB,
  GearDIALOGSLib_TLB,
  GearDISPLAYLib_TLB,
  GearEFFECTSLib_TLB,
  GearFORMATSLib_TLB,
  GearMEDLib_TLB,
  GearPDFLib_TLB,
  GearPROCESSINGLib_TLB,
  IGGUIDlgLib_TLB,
  IGGUIWinLib_TLB,
  VECTLib_TLB,
  OleCtrls,
  GearVIEWLib_TLB

;

//Uses Vetted 20090929:FileCtrl, Controls, Graphics, Messages, uMagClasses, umagdefinitions, cmagdbmvista, hash, Dialogs, Forms

type
  EInvalidData = class(Exception)
    ErrorCode: integer;
  end;

  TMytest4Event = procedure(I: integer; s: String) of object;

  TMagImport = class(TCustomListbox)
  private
    FUnStrings: Tstrings;
    FMyLogFile: TextFile;
    FLogStrs: Tstrings;
    FMyTest4Event: TMytest4Event;
    FImageAdd: string;
    {each image (listItem in FImages) can have 2nd '^' piece as Short Description.}
    FImages: Tstrings;
    FDFN: string;

    {/ JK 11/30/2009 - P108 /}
    FProcNew : String;
    FProcTIUTitle : String;
    FProcTIUText: TStrings;
    FProcTIUSignatureType: String;
    //-FProcTIUSignature: String;

    FProcPKG: string;
    FProcIEN: string;
    FProcDt: string;
    {   tracking number is a ';' delimited string.  2 pieces
        1 = the package ID    i.e. 8924 (tiu)  'DSS' (DSS)
        2 = some unique number in relation to the package. }
    FTrkNum: string;
    FAcqDev: string;
    FAcqSite: string;
    FAcqLoc: string;
    FExcpHandler: string;
    {  Above are required by the 'M' Import API Call.{}
    FImgType: string;
    FMethod: string;
    FCapBy: string;
    FUsername: string;
    FPassword: string;
    FGroupDesc: string;
    FDeleteFlag: boolean;
    FTransType: string;
    FDOCCTG: string;
    FixType: string;
    FixSpec: string;
    FixProc: string;
    FixOrigin: string;
    FDocDT: string;
    {   rest of fields are not Implemented in 'M' ImportAPI Call. {}
    FProcType: string;
    FProcDesc: string;
    FCapDt: string;
    FGroupIEN: string;
    FGroupLongDesc: Tstrings;
    {   other processing fields {}
    Flist: Tstringlist;
    rlist: Tstrings;
    Fstat: boolean;
    FBroker: TRPCBroker;
    FDBBroker: TMagDBBroker;
    FMagSecurity: TMag4Security;
    FMagSecurityNOTCreated : Tmag4Security;
    FCaptureKeys: Tstringlist;
    { --- FLogList is a record of events during the Import Process.  This may be warnings, etc. that are
          listed in the 3..n nodes.  After the 0,1,2 nodes, because the 0, 1, 2 nodes have specific info.}
    FLogList: Tstringlist;
    FMagUtils: TMagUtils;
    //121
    FImportActionValue : string;
    FImportIsRescind : boolean;
    FIoLocation : IIGIOLocation;
    FWaterMarkBitmap : string;
    FDirTemp : string;
    FDirCache : string;
    FDirImport : string;
    FDirImage : string;
    {/p135  Timer for BP's way to sync Timeout with VistA}
    FTimerStayAlive : TTimer;

    FSAvserver,
    FSAvport,
    FSAaccesscode,
    FSAverifycode,
    FSAdivision : string;
    FSALastLogon  : boolean;
    //
    function GetTrkNum : String;
    function GetImages : Tstrings;
    function GetAcqSite : String;
    function GetAcqLoc : String;
    function GetCapBy : String;
    function GetCapDt : String;
    function GetDFN : String;
    function GetImgType : String;
    function GetMethod : String;
    function GetProcDesc : String;
    function GetProcDt : String;
    function GetProcPKG : String;
    function GetProcIEN : String;
    function GetProcType : String;
    function GetAcqDev : String;
    function GetGroupIEN : String;
    function GetGroupDesc : String;
    function GetGroupLongDesc : Tstrings;
    function GetExcpHandler : String;
    function GetPassword : String;
    function GetUsername : String;
    function GetDeleteFlag : boolean;
    function GetTransType : String;
    function GetDOCCTG : String;
    function GetDocDt : String;
    function GetIndexProc : String;
    function GetIndexSpec : String;
    function GetIndexType : String;
    function GetIndexOrigin : String;
    procedure SetTrkNum(const Value: String);
    procedure SetImages(const Value: Tstrings);
    procedure SetAcqSite(const Value: String);
    procedure SetAcqLoc(const Value: String);
    procedure SetCapBy(const Value: String);
    procedure SetCapDt(const Value: String);
    procedure SetDFN(const Value: String);
    procedure SetImgType(const Value: String);
    procedure SetMethod(const Value: String);
    procedure SetProcDesc(const Value: String);
    procedure SetProcDt(const Value: String);

    {/ JK 11/30/2009 - P108 /}
//    function GetProcTIUSignature : String;
    function GetProcTIUSignatureType : String;
    function GetProcNew : String;
    function GetProcTIUTitle : String;
    function GetProcTIUText : TStrings;

    procedure SetProcPKG(const Value: String);
    procedure SetProcIEN(const Value: String);
    procedure SetProcType(const Value: String);
    procedure SetAcqDev(const Value: String);
    procedure SetGroupIEN(const Value: String);

    {/ JK 11/30/2009 - P108 /}
//    procedure SetProcTIUSignature(const Value: String);
    procedure SetProcTIUSignatureType(const Value: String);
    procedure SetProcNew(const Value: String);
    procedure SetProcTIUTitle(const Value: String);
    procedure SetProcTIUText(const Value: TStrings);
    procedure SetInsertProcTIUText(const Value: String);

    procedure SetGroupDesc(const Value: String);
    procedure SetGroupLongDesc(const Value: Tstrings);
    procedure SetExcpHandler(const Value: String);
    procedure SetPassword(const Value: String);
    procedure SetUsername(const Value: String);
    procedure SetDeleteFlag(const Value: boolean);
    procedure SetTransType(const Value: String);
    procedure SetDOCCTG(const Value: String);
    procedure SetDocDt(const Value: String);
    procedure SetIndexProc(const Value: String);
    procedure SetIndexSpec(const Value: String);
    procedure SetIndexType(const Value: String);
    procedure SetIndexOrigin(const Value: String);
    function GetBroker : TRPCBroker;
    function GetMag4Security : TMag4Security;
    function GetDBBroker : TMagDBBroker;
    procedure SetBroker(const Value: TRPCBroker);
    procedure SetMag4Security(const Value: TMag4Security);
    procedure SetDBBroker(const Value: TMagDBBroker);
    function Validate(var xmsg: String) : boolean;
    function CreateGroup(var xmsg: String) : boolean;
    function CreateImageEntry(var xmsg: String; var imageID: String; imagefile: String) : boolean;
    function CopyImageToServer(var xmsg: String; imageID, imagefile: String) :  boolean;
    function ValidInteger(s: String) : boolean;
    function SAVE(var xmsg: String) : boolean;
    function ImageArrayToFields(var xmsg: String; imgarray: Tstringlist) : boolean;
    function CopyTheFile(var xmsg: String; FromFile, ToFile: String; MakeTXT : boolean = true) : boolean;
    procedure FileSpecialtyPointers(imageID: String);
    procedure CreateTheQueues(imageID: String);
    function DelimitedParam(s: String) : boolean;
    function SetNetUsernamePassword(user, pass: String; var MagSec: TMag4Security;
                                    var xmsg: String) : boolean;
    procedure DeleteImageEntry(var xmsg: String; ien: String);
    procedure CreateNewlog;
    procedure LogTheMsg(s: String);
    procedure LogTheList(t: Tstringlist);  overload;
    procedure LogTheList(t: Tstrings);    overload;
    function ImageTypeAllowAbs(fileext: String) : boolean;
    function CreateAndSaveImageTextFile(imageToFile: String; var xmsg: String) : boolean;
    procedure InitIfNeeded;
    procedure ConnectIfNeeded(var vserver: String; var vport: String; accesscode:
                                             String = ''; verifycode: String = '';division : string = '');
    procedure ImageArrayFromFields(var t: Tstringlist);
    procedure LogDebugMsg(s: String);  overload;
    procedure LogDebugMsg(t: Tstrings; pf : string = ''); overload;
    function BoolToStr(val: boolean): string;

    {/p121 methods }
    procedure CreateAccusoftControls();
       procedure PreProcessRESCINDArray(var rstat : boolean; var rmsg : string; var rescindimage : string; var Flist: TStringlist);
         function  WaterMarkTheImage(var xmsg : string; filetomark : String; var NewFilename : string): boolean;
           procedure LoadImage1(filename: string);
           procedure LoadImage2WMK;
               function  GetWaterMarkBitmap(): string;
           function  GetWaterMarkFileName(filename: string; fileext : string=''): string;
    function SetIAPIDirectories(var Rmsg: String): Boolean;
    procedure WaterMarkConvertToGray;
    procedure WaterMarkResizeRescind;
    function GetArrayValue(value : String; imgarray: Tstringlist) : string;
    function GetNetSecurityOn: boolean;
    procedure SetNetSecurityOn(const Value: boolean);

  {121 end.}
   {/p135}
    function MagGetSystemTimeout(data : string): string;
    procedure StayAliveTimer(Sender: TObject);
  protected
    property height default 30;
    property width default 30;
  public
     FOnPulseErrorText : string;
     FApplicationPath : string;
    {/p121  start }
    vIGPage1, vIGPage2 : IGPage;
    vIGPageDisplay1, vIGPageDisplay2 : IGPageDisplay;

    // not needed in Import.  No Display GUI.   vIGPageViewCtl1, vIGPageViewCtl2, vIGPageViewCtl3 : TIGPageViewCtl;
    //vIoLocation: IIGIOLocation;
    vIGLoadOptions: IGLoadOptions;
    //vMedContrast: IGMedContrast;
    //vMedDataDict: IGMedDataDict;
    vIGSaveOptions: IGSaveOptions;
    {/121 end}
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ClearProperties;
    procedure showproperties;
    function StayAlive(value : boolean): string;

    procedure SaveDirect(var status: boolean; var xmsglist: Tstrings);
    procedure VistAInit(var status: boolean; var xmsg: String; var vserver: String;
                        var vport: String; accesscode: String =''
                        ; verifycode: String = ''
                        ; division: String = '');
    function ImportDataArray(var xmsglist: Tstringlist; InArray: Tstringlist) :
             boolean;
    procedure ImportQueue(var resStatus: boolean; Qnum: String; var reslist: Tstrings;
                          var StatusCB: String; NoCallBackOnError: boolean = FALSE);
    procedure ImageAdd(imagefile: String);

    {/ JK 11/24/2009 - P108 Add in new procedure IndexTypeList /}
    procedure IndexTypeList(var slType: TStringList;
                            ClassChoice: String = '';
                            IgnoreStatus: Boolean = False;
                            incClass: Boolean = False;
                            incStatus: Boolean = False);

    {/ JK 11/24/2009 - P108 Add in new procedure IndexSpecSubSpecList /}
    procedure IndexSpecSubSpecList(var slSubSpec: TStringList;
                                   ClassChoice: String = '';
                                   ProcsChoice: String = '';
                                   ignoreStatus: Boolean = False;
                                   incClass: Boolean = False;
                                   incStatus: Boolean = False;
                                   incSpec: Boolean = False);

    {/ JK 11/24/2009 - P108 Add in new procedure IndexEventList /}
    procedure IndexEventList(var slEvent: TStringList;
                             ClassChoice: String = '';
                             SpecChoice: String = '';
                             ignoreStatus: Boolean = False;
                             incClass : Boolean = False;
                             incStatus : Boolean = False);

    {/ JK 11/24/2009 - P108 Add in new procedure IndexOriginList /}
    procedure IndexOriginList(var slOrigin: TStringList);

    {/ JK 11/24/2009 - P108 Add in new procedure RPPatientHasPhoto /}
    function RPPatientHasPhoto(DFN: String;
                               var Stat: Boolean;
                               var FMsg: String): String;

  procedure IAPIOnPulseError(peBroker : TRPCBroker ; peErr : string);


  published
    property OnMyTest4Event : TMytest4Event read FMyTest4Event write  FMyTest4Event;
    property TrkNum : String read GetTrkNum write SetTrkNum;
    property Images : TStrings read GetImages write SetImages;
    property DFN : String read GetDFN write SetDFN;
    property CapBy : String read GetCapBy write SetCapBy;
    property AcqDev : String read GetAcqDev write SetAcqDev;
    property ExcpHandler : String read GetExcpHandler write SetExcpHandler;
    property ProcPKG : String read GetProcPKG write SetProcPKG;
    property ProcIEN : String read GetProcIEN write SetProcIEN;

    {/ JK 11/30/2009 - P108 /}
    property ProcNew: String read GetProcNew write SetProcNew;
    property ProcTIUTitle: String read GetProcTIUTitle write SetProcTIUTitle;
//    property ProcTIUSignature: String read GetProcTIUSignature write SetProcTIUSignature;
    property ProcTIUSignatureType: String read GetProcTIUSignatureType write SetProcTIUSignatureType;
    property ProcTIUText: TStrings read GetProcTIUText write SetProcTIUText;

    property ProcType : String read GetProcType write SetProcType;
    property Username : String read GetUsername write SetUsername;
    property Password : String read GetPassword write SetPassword;
    property ProcDt : String read GetProcDt write SetProcDt;
    property ProcDesc : String read GetProcDesc write SetProcDesc;
    property CapDt : String read GetCapDt write SetCapDt;
    property ImgType : String read GetImgType write SetImgType;
    property AcqSite : String read GetAcqSite write SetAcqSite;
    property Method : String read GetMethod write SetMethod;
    property GroupIEN : String read GetGroupIEN write SetGroupIEN;
    property GroupDesc : String read GetGroupDesc write SetGroupDesc;
    property GroupLongDesc : Tstrings read GetGroupLongDesc write SetGroupLongDesc;
    property DeleteFlag : boolean read GetDeleteFlag write SetDeleteFlag;
    property TransType : String read GetTransType write SetTransType;
    property AcqLocation : String read GetAcqLoc write SetAcqLoc;
    property DocCategory : String read GetDOCCTG write SetDOCCTG;
    property DocDate : String read GetDocDt write SetDocDt;
    property IndexType : String read GetIndexType write SetIndexType;
    property IndexSpec : String read GetIndexSpec write SetIndexSpec;
    property IndexProc : String read GetIndexProc write SetIndexProc;
    property IndexOrigin : String read GetIndexOrigin write SetIndexOrigin;
    property MagBroker : TRPCBroker read GetBroker write SetBroker;
    property MagSecurity : TMag4Security read GetMag4Security write SetMag4Security;
    property MagDBBroker : TMagDBBroker read GetDBBroker write SetDBBroker;
    {/p121 gek , surface a method to Turn security ON or OFF.  This is used by BP.}
    property NetSecurityOn : boolean read GetNetSecurityOn write SetNetSecurityOn;
  end;

procedure Register;

implementation

uses
  cMagDBMVista,
  Dialogs,
  Forms,
  hash,
  uMagClasses,
  umagdefinitions
  ;

procedure Register;
begin
  RegisterComponents('Imaging', [TMagImport])
end;


{ TMagImport }



constructor TMagImport.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Flist := Tstringlist.Create;
  rlist := Tstringlist.Create;
  FImages := Tstringlist.Create;
  FGroupLongDesc := Tstringlist.Create;
  FMagUtils := TMagUtils.Create(Self);
  FCaptureKeys := Tstringlist.Create;
  FLogList := Tstringlist.Create;
  height := 30;
  width := 30;
  FLogStrs := Tstringlist.Create;

  {/ JK 12/1/2009 - P108 /}
  FProcTIUText := TStringList.Create;
  {/p121 gek 3/18/11 }
  MagIGManager := TMagIGManager.Create();
  { TODO -cRefactor :
    carry rescinded bmp as a resource.  not a bitmap file.
    create file from resource, use that for Accusoft Watermark function. }
  FWaterMarkBitmap := 'c:\program files\vista\imaging\bmp\MagRescinded.bmp';
    FDirTemp := '' ;
    FDirCache := '' ;
    FDirImport := '' ;
    FDirImage := '' ;
  FTimerStayAlive := TTimer.Create(self);
  FTimerStayAlive.Enabled := false;
  FTimerStayAlive.OnTimer := StayAliveTimer;
end;


destructor TMagImport.Destroy;
begin
  Application.processmessages;
  Flist.Free;
  rlist.Free;
  FImages.Free;
  FGroupLongDesc.Free;
  FMagUtils.Free;
  FCaptureKeys.Free;
  FLogList.Free;

  {/ JK 12/1/2009 - P108 /}
  FProcTIUText.Free;

  inherited Destroy
end;





function TMagImport.ValidInteger(s: String) : boolean;
begin
  Result := true;
  try
    strtoint(s)
  except
    on E : Exception do
      Result := FALSE;
  end;
end;


function TMagImport.DelimitedParam(s: String) : boolean;
begin
  Result := true;
  if (FMagUtils.maglength(s, ';')<>2) then
  begin
    Result := FALSE
  end;
end;


function TMagImport.SAVE(var xmsg: String) : boolean;
var
  I: integer;
  ImageCopyErrors,
  ImageCopyOK: Tstrings;
  imsg,
  dmsg,
  imageID,
  imagefile: string;
  allornone: boolean;
  xien,
  xfile,
  x: string;
  IObj : TImageData;
begin
  // FUnstrings.add(inttostr(FUnstrings.count));
  rlist.clear;
  Flist.clear;
  allornone := true;
  Result := FALSE;
  FMagSecurity.MagCloseSecurity(imsg);
  imsg := '';
  ImageCopyErrors := Tstringlist.Create;
  ImageCopyOK := Tstringlist.Create;
  try
  try
    if not Validate(xmsg) then   // etrap ok.
    begin
      LogDebugMsg('2- Failed Validate');
      Result := FALSE;
      exit
    end;
    {--------------------------------}
    if FImages.Count=0 then
    begin
      xmsg := '0^Error: The list of Images to be imported is Empty.';
      Result := FALSE;
      exit
    end;
    //fUnStrings.Add(Inttostr(Funstrings.count)); // force error
    {--------------------------------}
    if ((FImages.Count>1) and (FGroupIEN='')) then
    begin
      if CreateGroup(xmsg) then        //etrap okk
      begin
        {error in FileSpecialtyPointers doesn't stop the process
               but the error is logged in LogTheMsg, which is returned to
               the calling App {}
        LogDebugMsg('2- Group Creating Image Group  OK');
        LogDebugMsg('2- Filing Package Pointers.');
        FileSpecialtyPointers(xmsg);          //etrap ok.
        LogDebugMsg('2- ------ ' + xmsg);
      end
      else
      begin
        LogDebugMsg('2- Error Creating Group.  Exiting Save.');
        Result := FALSE;
        exit //Can't Create the Group entry, so Stop here EXIT
      end;
    end;
    {--------------------------------}
    {  Here , we don't care if multiple images exist.
      IF FGroupIEN exists, we add each image to the Group.
      ELSE Each Image points to the Specialty(Procedure).{}
    //    if (FImages.Count > 0) then
    //    begin
    LogDebugMsg('2- Starting Save  Images.');
    LogDebugMsg('2- RPCBroker TimeLimit: ' + inttostr(FBroker.RPCTimeLimit));
    for I := 0 to FImages.Count - 1 do
    begin
      // we stop if one image fails, we wait untill
      // we have tried them all.  Unless AllorNone is True
      if not CreateImageEntry(imsg, imageID, FImages[I]) then    // etrap ok
      begin
        LogTheMsg('Error creating VistA Image Entry:');
        //LogTheMsg('    '+FImages[i]+'|'+imsg);
        LogTheMsg('    ' + imsg);
        ImageCopyErrors.Add('|' + FImages[I] + '|' + imsg);
        if allornone then
        begin
          LogDebugMsg('2- Breaking from Save Loop ');
          Result := FALSE;
          break
        end
        else
        begin
          continue
        end;
      end;
         { - - - - - - - - - }
      if FGroupIEN='' then
      begin
        FileSpecialtyPointers(imageID)        //etrap ok
      end;
      //FUnstrings.add(inttostr(FUnstrings.count));
      imagefile := FMagUtils.magpiece(FImages[I], '^', 1);
      // we don't stop if one copy fails, we wait untill
      // we have tried them all. Unless AllorNone is True
      LogDebugMsg('2- CopyImageToServer - imageID=' + imageID);
      LogDebugMsg('2- CopyImageToServer - imagefile=' + imagefile);
         { - - - - }
      if not CopyImageToServer(imsg, imageID, imagefile) then     //
      begin
        ImageCopyErrors.Add(imageID + '|' + FImages[I] + '|' + imsg);
        LogTheMsg('Error copying ' + imagefile + ' to Server : ' + imageID);
        LogTheMsg('   :' + imsg);
        // special return code, the Connection to the network failed.
        // so we stop processing.
        if ((FMagUtils.magpiece(imsg, '^', 1)='-1')
             or
            allornone) then
        begin
          xmsg := imsg;
          Result := FALSE;
          break
          //exit;
        end;
        continue
      end
      else    // success copying to server.
        begin
           LogDebugMsg('2- Copy To Server OK '+imagefile);
        end;
         { - - - - }
      ImageCopyOK.Add(imageID + '|' + FImages[I] + '|' + 'OK')
    end; //for I := 0 to Fimages.count - 1 do

    { TODO : if FMethod then CallMethodHandler(GenImages) }

    { We delete bad image entries now, that way only if all images were bad,
    will the group be deleted.{}
    if (ImageCopyErrors.Count>0) then
    begin
      for I := 0 to ImageCopyErrors.Count - 1 do
      begin
        DeleteImageEntry(dmsg, FMagUtils.magpiece(FMagUtils.magpiece(ImageCopyErrors[I], '|', 1), '^', 1));
        LogTheMsg(dmsg)
      end;
      if (allornone and (ImageCopyOK.Count>0)) then
      begin
        for I := ImageCopyOK.Count - 1 downto 0 do
        begin
          x := FMagUtils.magpiece(ImageCopyOK[I], '|', 1);
          xien := FMagUtils.magpiece(x, '^', 1);
          xfile := FMagUtils.magpiece(x, '^', 2) + FMagUtils.magpiece(x,
                              '^', 3);
          DeleteImageEntry(dmsg, xien);
          LogTheMsg(dmsg + '  Delete Queue set for: ' + xfile);
          // have to delete the Images from this list.  Because
          // the delete flag tests this list, for deleting images from import directory
          ImageCopyOK.Delete(I)
        end;
      end;
    end;
    //
    // HERE if things worked OK we have entries in ImageCopyOK list.
    //    ( we have things in ImageCopyOK list if some failed, and
    //      the allornothing flag wasn't set.
    //  So for all images in ImageCopyOK list,
    //           we should set the Queue's Here
    if (ImageCopyOK.Count>0) then
    begin
      for I := 0 to ImageCopyOK.Count - 1 do
      begin
        //CPMOD, ADMINMOD  12/6/2001
        //ImageCopyOK.add(imageID + '|' + FImages[i] + '|' + 'OK');
        {we LogTheMsg if CreateQueues fails. }
        CreateTheQueues(FMagUtils.magpiece(ImageCopyOK[I], '|', 1));
        // JMW 4/21/2005 p45
        IObj := TImageData.Create();
        IObj.ServerName := MagDBBroker.GetServer();
        IObj.ServerPort := MagDBBroker.GetListenerPort();
        MagDBBroker.RPMag3Logaction('CAP-IMPORT^' + FDFN + '^'
                   + FMagUtils.magpiece(ImageCopyOK[I], '^', 1) + '$$' + FTrkNum, IObj)
      end;
    end;
    if (ImageCopyOK.Count=0) then
    begin
      xmsg := '0^ERROR: 0 Images copied';
      Result := FALSE
    end
    else
    begin
      Result := true;
      xmsg := '1^' + IntToStr(ImageCopyOK.Count) + ' Image(s) Copied OK. ' +
              IntToStr(ImageCopyErrors.Count) + ' Errors.'
    end;
    // If this was a group, we have at least One image that was successful.
    {/P121  If this is a 'RESCIND' we force delete, because the files to delete are the New temporary  file
      that has the Watermark  i.e.   'WMK_ files.
      The Delete Queue will be set in the Status Callback, that will delete the old (rescinded) image from the Image Share}
    if (FDeleteFlag or FImportIsRescind) then
    begin
      // iterate through the ImageCopyOK array and delete all the
      //  2nd '|' pieces.
      for I := 0 to ImageCopyOK.Count - 1 do
      begin
        if not deletefile(FMagUtils.magpiece(FMagUtils.magpiece(ImageCopyOK[I],  '|', 2),'^',1))
        then
        begin
          LogTheMsg('0^Warning: Couldn''t Delete file: ' +
                 (FMagUtils.magpiece(FMagUtils.magpiece(ImageCopyOK[I],'|', 2), '^', 1)))
        end
        else
        begin
          LogTheMsg('1^Deleted the Imported File: ' + (FMagUtils.magpiece(FMagUtils.magpiece(ImageCopyOK[I], '|',2), '^', 1)))
        end;
      end;
    end;

  except
  on E:exception do
        begin
          result := false;
          xmsg := '0^'+ e.message;
          end;
   end;
finally
ImageCopyErrors.Free;
ImageCopyOK.Free
end;
end;


procedure TMagImport.CreateTheQueues(imageID: String);
var
  CreatAbsIEN,
  JBCopyIEN,
  imagefile,
  ext: string;
  xStat: boolean;
  xList: Tstringlist;
begin
  xList := Tstringlist.Create;
  try
    CreatAbsIEN := '';
    JBCopyIEN := FMagUtils.magpiece(imageID, '^', 1);
    imagefile := FMagUtils.magpiece(imageID, '^', 3);
    ext := FMagUtils.magpiece(imagefile, '.', 2);
    {Set Queues :  ABSTRACT, CopyToJukeBox
    First '^' piece is  CreateAbstract Queue
     2nd '^' piece is CopyToJukeBox }
    if ImageTypeAllowAbs(ext) then
    begin
      CreatAbsIEN := JBCopyIEN
    end;
    {RPMagABSJB(var Fstat: boolean; var Flist: tstringlist; CreatAbsIEN, JBCopyIEN: string)}
    FDBBroker.RPMagABSJB(Fstat, Flist, CreatAbsIEN, JBCopyIEN);
    if not Fstat then
    begin
      LogTheList(Flist)
    end;
    FDBBroker.RPMag4PostProcessActions(xStat, xList, JBCopyIEN)
  finally
    xList.Free
  end;
end;


function TMagImport.ImageTypeAllowAbs(fileext: String) : boolean;
var
  E: string;
begin
  E := ',' + UPPERCASE(fileext) + ',';
  Result := NOT (pos(E, ',MPG,ASC,AVI,DOC,HTM,PDF,RTF,WAV,TXT,MPEG,MHT,MHTML,HTML,MP3,MP4,')>0)
end;


{   Create a New Image Entry in the Image File, and Get IEN and FullPath  }
function TMagImport.CreateImageEntry(var xmsg: String; var imageID: String;
                                     imagefile: String) : boolean;
var
  t: Tstringlist;
  tmpext: string;
begin
  xmsg := '0^Error. Calling Remote Procedure.';
  t := Tstringlist.Create;
  try
    t.Add('5^' + FDFN);
    if (FGroupIEN='') then
    begin
      if (FProcPKG<>'') then
      begin
        t.Add('16^' + FProcPKG)
      end;
      if (FProcIEN<>'') then
      begin
        t.Add('17^' + FProcIEN)
      end;
    end
    else
    begin
      t.Add('14^' + FGroupIEN)
    end;
    if (FProcDt<>'') then
    begin
      t.Add('15^' + FProcDt)
    end;
    if (FDOCCTG<>'') then
    begin
      t.Add('100^' + FDOCCTG)
    end;
    if (FDocDT<>'') then
    begin
      t.Add('110^' + FDocDT)
    end;
    if (FixType<>'') then
    begin
      t.Add('42^' + FixType)
    end;
    if (FixSpec<>'') then
    begin
      t.Add('44^' + FixSpec)
    end;
    if (FixProc<>'') then
    begin
      t.Add('43^' + FixProc)
    end;
    if (FixOrigin<>'') then
    begin
      t.Add('45^' + FixOrigin)
    end;
    {tracking number is a ';' delimited  string.  2 pieces
        1 = the package ID    i.e. 8924 (tiu)  'DSS' (DSS)
        2 = some unique number in relation to the package. }
    { DONE : Do we want these with each image, or only the group?. A: YES }
    if (FTrkNum<>'') then
    begin
      t.Add('108^' + FTrkNum)
    end;
    if (FAcqDev<>'') then
    begin
      t.Add('ACQD^' + FAcqDev)
    end;
    if (FAcqSite<>'') then
    begin
      t.Add('ACQS^' + FAcqSite)
    end;
    if (FAcqLoc<>'') then
    begin
      t.Add('ACQL^' + FAcqLoc)
    end;
    //t.add...(FExcpHandler)
    { We don't care about the Status handler from this call
    The BP will send any error message to the calling package.
      It has the Exception handler }
    { The next fields are NOT Required}
    // The Image Type (OBJECT TYPE) can be internal number or free text
    if (FImgType<>'') then
    begin
      t.Add('3^' + FImgType)
    end;
    //ResolveImageType);
    if (FMethod<>'') then
    begin
      t.Add('109^' + FMethod)
    end; begin

      { TODO -ogarrett -cFields : Stuarts Component to Generate Images. }
      (*TImageMethodComponent.ResolveImages(FMethod,FImages);
        if (FImages.count = 0)
          then
            begin
              result := false;
              xmsg := 'Call to Generate Images returned ''0'' Images.');
              exit;
            end
         *)
    end;
    { example imagefile:= "c:\import\consent.tif^image description"
     P48 Fix to allow "." in image description
         Fix to allow "." in fullpath\filename
         Fix to allow extensions greater than 3 characters  i.e. ".HTML"}
    tmpext := UPPERCASE(copy(ExtractFileExt(FMagUtils.MagPiece(imagefile,'^',1)), 2, 99));
    if (tmpext='TXT') then
    begin
      tmpext := 'ASC'
    end;
    t.Add('EXT^' + tmpext);
    { CapturedBy is Not Implemented, we get from DUZ in VistA}
    if (FCapBy<>'') then
    begin
      t.Add('8^' + FCapBy)
    end;
    { FUsernamePassword not validated here}
    if (FGroupDesc<>'') then
    begin
      t.Add('10^' + FGroupDesc)
    end;
    { If image has own description, use that. {}
    if (FMagUtils.magpiece(imagefile, '^', 2)<>'') then
    begin
      t.Add('10^' + FMagUtils.magpiece(imagefile, '^', 2))
    end;
    { FDeleteFlag not used here.  It is queried later, after image has been copied.}
    { FTransType  not validated here, used in the 'Save' Call.    }
    { This is end of Fields that are sent as parameters }
    // FProcType
    if (FProcDesc<>'') then
    begin
      t.Add('6^' + FProcDesc)
    end;
    if (FCapDt<>'') then
    begin
      t.Add('7^' + FCapDt)
    end;
    { FGroupLongDesc not validated, it is sent as is ( if it exists)}
    FDBBroker.RPMag4AddImage(Fstat, Flist, t);
    //in procedure CreateImageEntry
    xmsg := Flist[0];
    Result := Fstat;
    if not Fstat then
    begin
      LogDebugMsg('3- Error AddImage');
      LogDebugMsg('3- '+xmsg);
      exit
    end;
   imageID := xmsg;
   LogDebugMsg('3- Image IEN: '+ imageID);
  finally
    t.Free
  end;
end;


function TMagImport.CreateGroup(var xmsg: String) : boolean;
var
  t: Tstringlist;
begin
  { here we Create a New Group in the Image File  {}
  t := Tstringlist.Create;
  try
    { Add the fields that say, this is a group}
    t.Add('2005.04^0');
    // A group with no children
    t.Add('3^11');
    //  11 says this is group; OBJECT TYPE
    t.Add('5^' + FDFN);
    if (FProcPKG<>'') then
    begin
      t.Add('16^' + FProcPKG)
    end;
    if (FProcIEN<>'') then
    begin
      t.Add('17^' + FProcIEN)
    end;
    if (FProcDt<>'') then
    begin
      t.Add('15^' + FProcDt)
    end;
    if (FDOCCTG<>'') then
    begin
      t.Add('100^' + FDOCCTG)
    end;
    if (FDocDT<>'') then
    begin
      t.Add('110^' + FDocDT)
    end;
    if (FixType<>'') then
    begin
      t.Add('42^' + FixType)
    end;
    if (FixSpec<>'') then
    begin
      t.Add('44^' + FixSpec)
    end;
    if (FixProc<>'') then
    begin
      t.Add('43^' + FixProc)
    end;
    if (FixOrigin<>'') then
    begin
      t.Add('45^' + FixOrigin)
    end;
    { Tracking number is a ';' delimited string.  2 pieces
        1 = the package ID    i.e. 8924 (tiu)  'DSS' (DSS)
        2 = some unique number in relation to the package. }
    if (FTrkNum<>'') then
    begin
      t.Add('108^' + FTrkNum)
    end;
    if (FAcqDev<>'') then
    begin
      t.Add('ACQD^' + FAcqDev)
    end;
    if (FAcqSite<>'') then
    begin
      t.Add('ACQS^' + FAcqSite)
    end;
    if (FAcqLoc<>'') then
    begin
      t.Add('ACQL^' + FAcqLoc)
    end;
    //t.add...(FExcpHandler)
    { We don't care about the exception handler. From this call
    The BP will send any error message to the calling package.
      It has the Exception handler }
    { The next fields are NOT Required}
    // The Image Type is already set by default for groups to '3^11';
    //if (FImgType <> '') then  t.add('3^'+FImgType); //ResolveImageType);
    if (FMethod<>'') then
    begin
      t.Add('109^' + FMethod)
    end; begin

      { TODO -ogarrett -cFields : Stuarts Component to Generate Images. }
      (*TImageMethodComponent.ResolveImages(FMethod,FImages);
        if (FImages.count = 0)
          then
            begin
              result := false;
              xmsg := 'Call to Generate Images returned ''0'' Images.');
              exit;
            end
         *)
    end;

    if (FCapBy<>'') then
    begin
      t.Add('8^' + FCapBy)
    end;
    // FUsernamePassword not validated here
    if (FGroupDesc<>'') then
    begin
      t.Add('10^' + FGroupDesc)
    end;
    // FDeleteFlag not used here.  It is queried later, after image has been copied.
    // FTransType  not validated here, used in the 'Save' Call.
    { This is end of Fields that are sent as parameters }
    // FProcType
    // FProcDesc
    // if (FCapDt <> '') then t.add('7^' + FCapDt);
    // FGroupIEN
    // FGroupLongDesc not validated, it is sent as is ( if it exists)
    // TESTING  Test sending a write directory ... did it work ?
    //t.add('WRITE^4');
    FDBBroker.RPMag4AddImage(Fstat, Flist, t);
    //procedure CreateGroup
    xmsg := Flist[0];
    Result := Fstat;
    if not Fstat then
    begin
      LogDebugMsg('3- Error Creating Group Image entry');
      exit ;
    end;

    FGroupIEN := FMagUtils.magpiece(xmsg, '^', 1);
      LogDebugMsg('3- Group IEN: '+FGroupIEN);
  finally
    t.Free
  end;
end;


(*
Procedure TMagImport.FormatData;
//var
//  SS: string;
//  FileEXT: string;
//  tempimagetype: shortint;
begin
// Here we take the data and make the ImageArray
//   in the format Field^Data  or ActionCode^Data

// this is copy of FileImage from Tele19nu.pas
//   we following it to make sure we have all data we need.
//  to make a new call to Save Image Data.

// If this is a group, File the Group entry, then Loop through the Images
//  and file each one.
//  If one Image is successfully saved to VistA and Image Network Server.
//  then call will be successful.  EVEN if other Images fail.
//  other Images will be saved locally, or to network and somehow flagged ,
//  as a failed copy.  A File (.inf) or something will be saved along side the
//  image file.  This file will have pertinant information.  i.e. the info that
//  was in this component when the attempt to save the image failed.

  tempimagetype := 0;
  msg('', 'Filing the Image data...');
  if not xBrokerx.Connected then
  begin
    imagefiled := false;
    msg('d', 'No VistA Connection. Cannot Save Image.');
    exit;
  end;
  screen.cursor := crHourGlass;
  Memo2.Clear;
  xBrokerx.Param[0].Value := '.X';
  xBrokerx.Param[0].PType := list;
  LoadStaticFields;
  LoadSpecialtyFields;
  ss := uppercase(extractfileext(filenmx));
  if (uppercase(extractfileext(filenmx)) = '.AVI') and (imagetype <> 21)
    then if messagedlg('Importing Motion Video  (*.AVI) File ' + ss,
      mtconfirmation, [mbok, mbcancel], 0) <> mrOK then
    begin
      imagefiled := false;
      exit;
    end
    else
    begin
      tempimagetype := imagetype;
      imagetype := 21;
    end;
  if MagConfig.PhotoID.checked then
  begin
    tempimagetype := imagetype;
    imagetype := 18;
  end;
  if MagConfig.imagegroup.checked then
  begin
    xBrokerx.Param[0].Mult['"GROUP"'] := '14^' + GrpPtr;
    if DoesFormExist('DicomNumbers')
      then
    begin
      xBrokerx.Param[0].Mult['"DICOMSN"'] := 'DICOMSN^' + DicomNumbers.eDSN.TEXT;
      xBrokerx.Param[0].Mult['"DICOMIN"'] := 'DICOMIN^' + DicomNumbers.eDIN.TEXT;
    end;
  end;
  xBrokerx.Param[0].Mult['"OBJTYPE"'] := '3^' + IntToStr(ImageType);
  Memo2.Lines.Add('OBJTYPE^' + '3^' + IntToStr(ImageType));
  if tempimagetype <> 0 then
  begin
    imagetype := tempimagetype;
  end;
  FileEXT := Copy(Format, 2, 3);
  if Scanmode = 'Import' then
  begin
    if ImportIni = 'COPY' then FileEXT := Copy(ExtractFileExt(FileNmx), 2, 3);
    if ImportIni = 'TGA' then FileEXT := 'TGA';
  end;
  xBrokerx.Param[0].Mult['"FileExt"'] := 'EXT^' + FileExt;
//  gek 2/18/97 { TEST PETE'S "WRITE^PACS"  }
{--  xBrokerx.Param[0].Mult['"PACSWRITE"']:='WRITE^PACS';   gek 2/18/97}
{-- the TEST worked OK, but DON'T uncomment these lines}
{ test the BIG File flag  }

// If importing w/copy all and big file exists, set fbig node in 2005 saf 12/8/98
  if (MagBatchAdv.CopyAll.Checked and FileExists(lbImport.caption + '\' + FMagUtils.magpiece(FileNmx, '.', 1) + '.big')) then
    SaveBig := True;

  if SaveBig then xBrokerx.Param[0].Mult['"bigfile"'] := 'BIG^1';
  Memo2.Lines.Add('FileExt^EXT^' + FileEXT);
{ABS created on ws}
  if (ABSCreated and ABSforImage) then xBrokerx.Param[0].Mult['"NETLOCABS"'] := 'ABS^STUFFONLY';
   {GEK 4/16/97 STOP ABS ON 1 BIT TIF.}

  if (AbsCreated and MagBatchAdv.CopyAll.Checked) then xBrokerx.Param[0].Mult['"NETLOCABS"'] := 'ABS^STUFFONLY';
   // if copying abs on import, set abs pointer saf 12/8/98

  if (Writedir <> '') then xBrokerx.Param[0].Mult['"WRITEDIR"'] := '2^' + WRITEDIR;
  screen.cursor := crHourglass;
  //oldcopy  xBrokerx.remoteprocedure := 'MAGGADDIMAGE';
  ss := xBrokerx.STRcall;
  screen.cursor := crDefault;
  msg('s', ss);
  ImgPtr := FMagUtils.magpiece(sS, '^', 1);
  magien := ImgPtr;
  if ((ImgPtr = '0') or (ImgPtr = '')) then
  begin
    msg('', 'Image data NOT FILED : ' + FMagUtils.magpiece(sS, '^', 2));
    messagebeep(0);
    imagefiled := false;
    magien := '';
    exit;
  end;
  msg('', 'The Image data was filed OK');
  dirx := FMagUtils.magpiece(sS, '^', 2);
  FileSave := FMagUtils.magpiece(sS, '^', 3);
  MagImageFullPathAndName := dirx + filesave;
  FileSave := FMagUtils.magpiece(FileSave, '.', 1);
  if MagConfig.imagegroup.checked then ImagePtrLst.Items.Add(ImgPtr + '^' + FileSave);
  Memo2.Lines.Add('FILENAME^1^' + FileSave + Format);

//If not(UpperCase(Remote)='NONE') then
//      begin
//      Memo2.Lines.SaveToFile(tempdir + FileSave + '.txt');
//      Memo2.Clear;
//      end;
  imagefiled := true;

end;  *)
procedure TMagImport.ClearProperties;
begin
  FDFN := '';
  FImages.clear;
  FProcPKG := '';
  FProcIEN := '';
  FProcDt := '';

  {/ JK 11/30/2009 - P108 /}
  FProcNew := '';
  FProcTIUTitle := '';
  //-FProcTIUSignature := '';
  FProcTIUSignatureType := '';

  FTrkNum := '';
  FAcqDev := '';
  FAcqSite := '';
  FExcpHandler := '';

  FImgType := '';
  FMethod := '';
  FCapBy := '';
  FUsername := '';
  FPassword := '';
  FAcqLoc := '';
  FDOCCTG := '';
  FDocDT := '';
  FixType := '';
  FixSpec := '';
  FixProc := '';
  FixOrigin := '';

  FGroupDesc := '';
  FDeleteFlag := FALSE;
  FTransType := 'NEW';

  FCapDt := '';
  FProcType := '';
  FProcDesc := '';
  FGroupIEN := '';
  FGroupLongDesc.clear
end;


procedure TMagImport.ImageArrayFromFields(var t: Tstringlist);
var
  ict: integer;
  i: Integer;
begin
  { here we reformat the Imaging Fields from the component into an array
  and call The RPValidate function. {}
  t.clear;
  t := Tstringlist.Create;

  t.Add('IDFN^' + FDFN);

  {/ JK 11/30/2009 - P108 /}
  if (FProcNEW <> '') then
  begin
    t.Add('PXNEW^' + FProcNEW)
  end;

  if (FProcTIUTitle <> '') then
  begin
    t.Add('PXTIUTTL^' + FProcTIUTitle)
  end;

//  if (FProcTIUSignature <> '') then
//  begin
//    t.Add('PXTIUSGN^' + FProcTIUSignature)
//  end;

  if (FProcTIUSignatureType <> '') then
  begin
    t.Add('PXSGNTYP^' + FProcTIUSignatureType)
  end;

  t.add('PXTIUTCNT^' + IntToStr(FProcTIUText.Count));

  for i := 0 to FProcTIUText.Count - 1 do
  begin
    t.Add('PXTIUTXT' + IntToStr(i) + '^' + FProcTIUText[i])
  end;



  if (FProcPKG<>'') then
  begin
    t.Add('PXPKG^' + FProcPKG)
  end;
  if (FProcIEN<>'') then
  begin
    t.Add('PXIEN^' + FProcIEN)
  end;
  if (FProcDt<>'') then
  begin
    t.Add('PXDT^' + FProcDt)
  end;
  { Tracking Number is ';' delimited string.  2 pieces
        1 = the package ID    i.e. 8924 (tiu)  'DSS' (DSS)
        2 = some unique number in relation to the package. }
  if (FTrkNum<>'') then
  begin
    t.Add('TRKID^' + FTrkNum)
  end;
  { Acq Dev Field = Computer Name}
  if (FAcqDev<>'') then
  begin
    t.Add('ACQD^' + FAcqDev)
  end;
  if (FAcqSite<>'') then
  begin
    t.Add('ACQS^' + FAcqSite)
  end;
  if (FAcqLoc<>'') then
  begin
    t.Add('ACQL^' + FAcqLoc)
  end;
  t.Add('STSCB^' + FExcpHandler);

  { The next fields are NOT Required, so test for ''}
  if (FImgType<>'') then
  begin
    // t.add(ResolveImageType);
    {TODO: make an RPC so other vendors can get list of
         image types and image type IENS, then this field will
         valildate just like any other.
        HERE we assume the image type is from our list.}
    t.Add('ITYPE^' + FImgType)
  end;
  { TODO -ogarrett -cFields : create Function ResloveImageType }
  if (FMethod<>'') then
  begin

    { TODO -ogarrett -cFields : Stuarts Component to Generate Images. }
    (*TImageMethodComponent.ResolveImages(FMethod,FImages);
        if (FImages.count = 0)
          then
            begin
              result := false;
              xmsg := 'Call to Generate Images returned ''0'' Images.');
              exit;
            end
         *)
  end;
  if (FCapBy<>'') then
  begin
    t.Add('CDUZ^' + FCapBy)
  end;
  { DONE :  FDOCCTG and FDocDt. DocDt and PXDT could both have values.
           DocDT is field 110 in image file.  DOCUMENT DATE}
  if (FDOCCTG<>'') then
  begin
    t.Add('DOCCTG^' + FDOCCTG)
  end;
  if (FDocDT<>'') then
  begin
    t.Add('DOCDT^' + FDocDT)
  end;
  if (FixType<>'') then
  begin
    t.Add('IXTYPE^' + FixType)
  end;
  if (FixSpec<>'') then
  begin
    t.Add('IXSPEC^' + FixSpec)
  end;
  if (FixProc<>'') then
  begin
    t.Add('IXPROC^' + FixProc)
  end;
  if (FixOrigin<>'') then
  begin
    t.Add('IXORIGIN^' + FixOrigin)
  end;
  // FUsername
  // FPassword not validated here
  if (FGroupDesc<>'') then
  begin
    t.Add('GDESC^' + FGroupDesc)
  end;
  // FDeleteFlag not used here.  It is queried later, after image has been copied.
  // FTransType  not validated here, used in the 'Save' Call.
  { This is end of Fields that are implemented }
  // FProcType
  // FProcDesc
  // if (FCapDt <> '') then t.add('7^' + FCapDt);
  // FGroupIEN
  // FGroupLongDesc not validated, it is sent as is ( if it exists)
  if (FImages.Count>0) then
  begin
    for ict := 0 to FImages.Count - 1 do
    begin
      t.Add('IMAGE^' + FImages[ict])
    end;
  end;
end;


function TMagImport.Validate(var xmsg: String) : boolean;
var
  t: Tstringlist;
begin
  { here we reformat the Imaging Fields from the component into an array
  and call The RPValidate function. {}
  //result := false;
  t := Tstringlist.Create;
  try
    t.Add('5^' + FDFN);
    if (FProcPKG<>'') then
    begin
      t.Add('16^' + FProcPKG)
    end;
    if (FProcIEN<>'') then
    begin
      t.Add('17^' + FProcIEN)
    end;
    if (FProcDt<>'') then
    begin
      t.Add('15^' + FProcDt)
    end;
    { Field for Tracking Number is a delimited string.  2 pieces
        1 = the package ID    i.e. 8924 (tiu)  'DSS' (DSS)
        2 = some unique number in relation to the package. }
    t.Add('108^' + FTrkNum);
    { Acq Dev Field = Computer Name}
    //10-23-03 GEK p8t31 Changed 107 to ACQD  We add new entries to the
    //   Acquisition Device File, if they don't exist.  BUT the Action Code
    //    ACQD does this, not Field 107
    //10-23-03 gek p8t31 t.add('107^' + FAcqDev);
    // THIS WORKED it added the new Acquisition Device FM entry.
    //   but not
    t.Add('ACQD^' + FAcqDev);
    //p8t21 t.add('.05^' + FacqSite);
    t.Add('ACQS^' + FAcqSite);
    //P8T21 if (FAcqLoc <> '') then t.add('101^' + FacqLoc);
    if (FAcqLoc<>'') then
    begin
      t.Add('ACQL^' + FAcqLoc)
    end;
    { DONE : We need to send ACQS and ACQL instead of the field #'s to populate
the Acquisition Device file.}
    //t.add...(FExcpHandler)
    { We don't care about the exception handler. From this call
    The BP will send any error message to the calling package.
      It needs the Exception handler }
    { The next fields are NOT Required, so  need to test for ''}
    if (FImgType<>'') then
    begin

      // t.add(ResolveImageType);
      // WE might make an RPC so other vendors can get list of
      //  image types and image type IENS, then this field will
      //  valildate just like any other.
    end;
    { TODO -ogarrett -cFields : create Function ResloveImageType }
    if (FMethod<>'') then
    begin

      { TODO -ogarrett -cFields : Stuarts Component to Generate Images. }
      (*TImageMethodComponent.ResolveImages(FMethod,FImages);
        if (FImages.count = 0)
          then
            begin
              result := false;
              xmsg := 'Call to Generate Images returned ''0'' Images.');
              exit;
            end
         *)
    end;
    if (FCapBy<>'') then
    begin
      t.Add('8^' + FCapBy)
    end;
    { DONE :  FDOCCTG and FDocDt. DocDt and PXDT could both have values.
           DocDT is field 110 in image file.  DOCUMENT DATE}
    if (FDOCCTG<>'') then
    begin
      t.Add('100^' + FDOCCTG)
    end;
    if (FDocDT<>'') then
    begin
      t.Add('110^' + FDocDT)
    end;
    if (FixType<>'') then
    begin
      t.Add('42^' + FixType)
    end;
    if (FixSpec<>'') then
    begin
      t.Add('44^' + FixSpec)
    end;
    if (FixProc<>'') then
    begin
      t.Add('43^' + FixProc)
    end;
    if (FixOrigin<>'') then
    begin
      t.Add('45^' + FixOrigin)
    end;
    // FUsername
    // FPassword not validated here
    if (FGroupDesc<>'') then
    begin
      t.Add('10^' + FGroupDesc)
    end;
    // FDeleteFlag not used here.  It is queried later, after image has been copied.
    // FTransType  not validated here, used in the 'Save' Call.
    { This is end of Fields that are sent as parameters }
    // FProcType
    // FProcDesc
    // if (FCapDt <> '') then t.add('7^' + FCapDt);
    // FGroupIEN
    // FGroupLongDesc not validated, it is sent as is ( if it exists)
    FDBBroker.RPMag4ValidateData(Fstat, Flist, t, '1');
    xmsg := Flist[0];
    Result := Fstat;
    if not Fstat then
    begin
      LogTheList(Flist)
    end

  finally
    t.Free
  end;
end;


function TMagImport.ImportDataArray(var xmsglist: Tstringlist; InArray: Tstringlist) :
boolean;
var
  stat: boolean;
begin
  Maglogger.Log(Trace, 'Entered TMagImport.ImportDataArray');
  Maglogger.LogList(Info, InArray);
  FDBBroker.RPMag4RemoteImport(stat, xmsglist, InArray);
  Result := stat;
  //Maglogger.Log(Trace, 'Exited TMagImport.ImportDataArray');
end;


procedure TMagImport.ImportQueue(var resStatus: boolean; Qnum: String; var reslist:  Tstrings; var StatusCB: String;  NoCallBackOnError: boolean = FALSE);
var
  xmsg: string;
  ok: boolean;
  vserver,
  vport,
  savestat: string;
  DoStatusCB: boolean;
    //p121 VLER
    shares: tstringlist;
    RPmsg: string;
    success: boolean;
  rstat : boolean;
  rmsg : string;

  rescindImage, RescindImageRaw : string;
begin
  FImportActionValue := ''   ;
  FImportIsRescind := false;
  rescindImage := '';

  Maglogger.Log(Trace, '>>> Entered TMagImport.ImportQueue >>>');


  { ---- If problem with VistA connection, we stop. ---- }
  VistAInit(ok, xmsg, vserver, vport);
  if not FBroker.Connected then
  begin
    resStatus := FALSE;
    Qnum := '0';
    reslist.Add('0^No Connection to VISTA.');
    exit
  end;
  // reslist.Add('Connected: ' + vserver + ',' + vport);

  try

  {  ----  if we can't create directories, (unlikely) we'll have to stop ---- }
  If Not SetIAPIDirectories(Rmsg) Then
     begin
     resStatus := false;
            LogDebugMsg(Rmsg);
     reslist.insert(0,'0^'+rmsg);
     exit;
     end;

    {Create a New array for logging events/actions/warnings.;}
    FLogList.clear;

          LogDebugMsg('1- Log cleared.');
          LogDebugMsg('Param: Qnum= '+Qnum);
          LogDebugMsg('Param: StatusCB= '+StatusCB);
          LogDebugMsg('Param: NoCallBckErr= '+BoolToStr(NoCallBackOnError));

    {Initialize the results list, and default the result status to False.}
    reslist.clear;
    resStatus := FALSE;
    { get the data that was saved in the Import Queue File IMPORT QUEUE(#2006.34)}
    FDBBroker.RPMag4DataFromImportQueue(Fstat, Flist, Qnum);
    if not Fstat then
    begin
      reslist.assign(Flist);
      exit
    end;
    LogDebugMsg('1- Data from Queue OK.');

    {p/121 or VLER,  get list of shares, and set MagSecurityProperty, to handle UserName Password.}
    Shares := tstringlist.create;
    FDBBroker.RPMagGetNetLoc(success, RPmsg, Shares, 'ALL');
    FMagSecurity.ShareList := Shares;
    Shares.Free;
    {/p121 VLER  end.}

  //121
  {  ---- first, in 121, we need to get data for Tracking ID, StatusCB, so we can process
          and RPC to send the results back.  New function to Get data Value from Array.}

  //FTrkNum
  FtrkNum := GetArrayValue('108',flist);
  //FExcpHandler
  FExcpHandler := GetArrayValue('STATUSCB',flist);
  StatusCB := FExcpHandler ;

    try
// *********   121 start

    { TODO -c121 :
[  ] A) IF Action = Rescind
[  ] B) call RPC to get Data from MAGIEN
       > Chnge - modified Rescind MAGGSIU4 M rtns to set Import Queue with data from
        the image entry.  so B can wait or not needed. later.
[  ] C) create an FList array in the expected format.... like this was a normal Import
[  ] D) Copy the Image From the Share to the wrkstation
        rename it on Wrks.
        What directory to put it in.

[  ] E) Watermark the Image.
        New filename  = filename_Rescind.*
        Add it to Flist.items[i]="IMAGE^....
       Set the delete Flag, to delete on successful import.
[  ] F) then just continue

[  ] G) BUT at end, the Results that are sent to STATCB need to have extra items
        n... n+1  etc have ACTION^     IMAGE^<full path to image>
        so we can set the Delete Queue.}

//**********    121  end
{/p121 if ACTION=RESCIND, then Pre-Process array first.}


 // new 121 ACTION property
FImportActionValue :=  GetArrayValue('ACTION',flist);


//if GetImportACTION(Flist)='RESCIND' then
if FImportActionValue = 'RESCIND' then
   begin
     FImportISRescind := true;
     try
     CreateAccusoftControls;
     except
     on e:exception do
       begin
         resStatus := false;
         reslist.insert(0,'0^'+e.Message)  ;
         reslist.insert(1,FtrkNum);
         reslist.Insert(2,Qnum);
         exit;
       end;

     end; {exception}
     {Here we create the WaterMarked Image, and Put it in  Flist[]',
       rescindImage will be returned.  It's the Actual (existing) Image that is being Rescinded.  ...  }
     PreProcessRESCINDArray(rstat, rmsg, rescindimage, Flist);
     if not rstat  then
       begin
         resStatus := false;
         reslist.insert(0,'0^'+rmsg);
         reslist.insert(1,FtrkNum);
         reslist.Insert(2,Qnum);
         exit;
       end;
   end;


      // all Properties are defined in the next call, FtrkNUM is one of them
      if ImageArrayToFields(xmsg, Flist) then
      begin
        LogDebugMsg('1- Image Array To Fields. OK.');
        LogDebugMsg('1- Calling SAVE...');
// Calling SAVE
        resStatus := SAVE(xmsg);
//Save has been called.
        savestat := booltostr(resStatus);
        LogDebugMsg('1- Save Status :  ' + savestat)
      end
      else
      begin
        LogDebugMsg('1- ArrayToFields FALSE');
        LogDebugMsg('1- ' + xmsg);
        if (FMagUtils.magpiece(xmsg, '^', 1)<>'0') then
        begin
          LogDebugMsg('1-  ERROR Status and 0 node mismatch')
        end;
      end;

    except
      on E : Exception do
        begin
          LogDebugMsg('1- Exception:  ' + E.Message);
          resStatus := FALSE;
          xmsg := '0^' + E.Message
          //LogDebugMsg('Exception : ' + E.message);
        end;
    end;
    { Status Callback : our M routine will call their Status Callback{}
    {Patch P8T32  IMport API will call the Status Callback routine.}
    {  if success, but warnings, then change the '1^' to a '2^'.{}
    if ((FMagUtils.magpiece(xmsg, '^', 1)='1') and (FLogList.Count > 0)) then
    begin
      xmsg := '2' + copy(xmsg, 2, 999)
    end;
    FLogList.insert(0, xmsg);
    FLogList.insert(1, FTrkNum);
    FLogList.insert(2, Qnum);
    LogDebugMsg('End- Status: '+booltostr(resStatus));
    LogDebugMsg('End- NoCallBackOnError: '+booltostr(NoCallBackOnError));
    LogDebugMsg('End- Status Callback:  '+FexcpHandler);
    reslist.assign(FLogList);
    StatusCB := FExcpHandler
  finally
    { Patch P8T32  IMport API will call the Status Callback routine.
      based on new param NoCallBackOnError    {}
    DoStatusCB := ((resStatus) or ((not resStatus) and (not NoCallBackOnError)));

    { DONE -c121 : Need to return (to VistA) the fullpathtoFile for delete Queue to process .
              This data is beign kept in Session file.  We return full file here, but it
              isn't used.  Okay.}
    if FImportIsRescind then
       reslist.Add('RESCINDED IMAGE FILE^' + rescindimage)  ;
    MagDBBroker.RPMag4StatusCallback(reslist, FExcpHandler, DoStatusCB);

    //Maglogger.LogList(Info, FLogList);

    //Maglogger.Log(Trace, '<<< Exited TMagImport.ImportQueue <<<');
  end;
end;

{/p121 functions for Watermarking}
{Function GetImportACTION(Flist: Tstringlist): string;   was deleted.  This call is generic for any value}

function TMagImport.GetArrayValue(value : String; imgarray: Tstringlist) : string;
var
  I: integer;
  fld,
  data: string;
begin
result := '';
  for I := 0 to imgarray.Count - 1 do
  begin
      fld := FMagUtils.magpiece(imgarray[I], '^', 1);
      data := copy(imgarray[I], pos('^', imgarray[I]) + 1, 999);
      if fld = value then
         begin
         result := data;
         break;
         end;
  end;
end;




procedure TMagimport.CreateAccusoftControls();  //AssociateControls();
//var
// force Error to test  //Tob : TEdit;
begin
// force error to test //tob.SetFocus;
{code base :   from FMag4VGear14}
      // create new save and load options
   { DONE -c121 : [Okay.] Only create, if not already created. }
if not assigned(vIGSaveOptions) then
  begin
  vIGSaveOptions := MagIGManager.IGFormatsCtrl.CreateObject(IG_FORMATS_OBJ_SAVEOPTIONS) As IIGSaveOptions;
  vIGSaveOptions.Format := IG_SAVE_UNKNOWN;
  end;

if not assigned(vIGLoadOptions) then
  begin
  vIGLoadOptions := MagIGManager.IGFormatsCtrl.CreateObject(IG_FORMATS_OBJ_LOADOPTIONS) As IIGLoadOptions;
  vIGLoadOptions.Format := IG_FORMAT_UNKNOWN;
  end;
    // create new page and page display objects , associate with page view control
if not assigned(vIGPage1) then
  begin
  vIGPage1 := MagIGManager.IGCoreCtrl.CreatePage;
  vIGPageDisplay1 := MagIGManager.IGDisplayCtrl.CreatePageDisplay(vIGPage1);
  end;
if not assigned(vIGPage2) then
  begin
  vIGPage2 := MagIGManager.IGCoreCtrl.CreatePage;
  vIGPageDisplay2 := MagIGManager.IGDisplayCtrl.CreatePageDisplay(vIGPage2);
  end;
end;


procedure TMagimport.LoadImage1(filename : string);
//var IoLocation : IIGIOLocation;
begin
  vIGPageDisplay1.Layout.alignment := IG_DSPL_ALIGN_X_CENTER Or IG_DSPL_ALIGN_Y_CENTER;
      vIGPageDisplay1.Layout.UseImageResolution := True; // JMW p72 12/8/2006 - use image resolution for aspect ratio

  //    IoLocation := GetIGManager.IGFormatsCtrl.CreateObject(IG_FORMATS_OBJ_IOFILE) As IIGIOLocation;
  //    (IoLocation As IGIOFile).Filename := Filename;
      MagIGManager.IGFormatsCtrl.LoadPageFromFile(vIGPage1, Filename, 0); //dialogLoadOptions.PageNum);

////if assigned(vIGPageViewCtl1) then   vIGPageViewCtl1.UpdateView;
end;

function TMagImport.GetWaterMarkBitmap(): string;
begin
  result := FWaterMarkBitmap;
end;

procedure TMagimport.LoadImage2WMK();
var IoLocation : IIGIOLocation;
filename : string;
begin
filename := GetWaterMarkBitmap;

  vIGPageDisplay2.Layout.alignment := IG_DSPL_ALIGN_X_CENTER Or IG_DSPL_ALIGN_Y_CENTER;
      vIGPageDisplay2.Layout.UseImageResolution := True; // JMW p72 12/8/2006 - use image resolution for aspect ratio

      IoLocation := GetIGManager.IGFormatsCtrl.CreateObject(IG_FORMATS_OBJ_IOFILE) As IIGIOLocation;
      (IoLocation As IGIOFile).Filename := Filename;
      MagIGManager.IGFormatsCtrl.LoadPageFromFile(vIGPage2, Filename, 0); //dialogLoadOptions.PageNum);

////if assigned(vIGPageViewCtl2) then   vIGPageViewCtl2.UpdateView;
end;



{/p121  PreProcessRESCINDArray
        In this procedure the IMAGE item of the input data array, is changed to the name of the newly created
         Watermarked Image... format 'WMK_imageIEN.Ext' .   later we need to delete this WMK_ file.  Regardless of DELFLAG. }


procedure TMagimport.PreProcessRESCINDArray(var rstat : boolean; var rmsg : string; var rescindimage : string; var Flist: TStringlist);
var I : integer;
    s : string;
    magien : string;
    xmsg : string;
    tmpImage, tmpExt, tmpDir ,tmpFileName, WMKfilename: string;
    ImageItem : integer;
begin
  rstat := false;
  rmsg := 'Pre-Processing for Rescind action...';
  rescindImage := '';
  {/p121 rethink the DelFlag... the BP will be deleting the image
    later.  We'll leave for now.... magSecurity won't be open...let BP do it.}
  {/p121  gek.  We set the DelFlag here}
  /// Flist.Add('DELFLAG^1');
  for i := 0 to fList.Count - 1 do
    begin
      s :=  fmagutils.MagPiece(flist[i],'^',1);
      if s = 'IMAGE' then
        begin
          imageItem := i;
          magien :=  fmagutils.MagPiece(flist[i],'^',2);
          rescindimage := fmagutils.MagPiece(flist[i],'^',3);
          break;
        end;
    end;
  if rescindimage = '' then
    begin
      rmsg := 'Image is missing from input data.';
      exit;
    end;

    { DONE  -c121 :
      use, users's directory and 'force temp directory in that' copy to that,
      watermark, rename, return new name, and that'll be imported.
      New function SetIAPIDirectories - create the variables if needed.}

{/p121 we need a temp file name.  for now prototype use C:\temp <- now FDirTemp 5/9/11}
if FDirTemp = '' then  FDirTemp := 'C:\temp\';

tmpImage := 'magtemp'+magien;
tmpExt := extractfileext(rescindimage);
tmpFileName := FDirTemp + tmpImage + tmpExt;

{/p121  if the file exists.  Delete it. (CopyTheFile doesn't delete it.)   We don't want to require User Interaction.}
if FileExists(tmpFileName) then  deleteFile(tmpfilename);

{the TXT File is created in the CopyTheFile function, unless we send False as 4th param
   so we send False now, because it will get created later in the actual Import.}
rstat := CopyTheFile(xmsg,rescindimage,tmpFileName,false);
if not rstat then
  begin
    rmsg := xmsg;
    exit;
  end;
      { DONE -c121 : need to return array for reason for failure... }
rstat := WaterMarkTheImage(xmsg,tmpFilename,WMKfilename);
if not rstat then
  begin
    rmsg := xmsg;
    exit;
  end;
(*if not CreateAndSaveImageTextFile(WMKFilename, xmsg) then
  begin
   rstat := false;
   rmsg := xmsg;
   exit;
  end; *)
{now delete the temp file names.  }
DeleteFile(tmpfilename);
//DeleteFile(changefileext(tmpfilename,'.txt'));
{/p121 here the Image is watermarked and now we just substitue the
   watermarked image as the 'new' image and continue.  sure... it's that easy.}
 { DONE -c121 : Should we Create TXT file here, with WMK name ? not before this. Don't want to change and Break anything though...
    NO, the CopyTheFile function will make the TXT file, unless we tell it not to .}
flist[imageitem] := 'IMAGE^' + WMKfileName

end;

function TMagImport.WaterMarkTheImage( var xmsg : string; filetomark : String; var Newfilename : string): boolean;
var i : integer;
rmsg : string;
//////////
pg ,pgct,h,w ,bits: integer;
 pImageFormat : enumIGformats;
 pIntegerformat : integer;
 pgInfo: IGFormatPageInfo;
WMKfilename : string;
fileExt : string;
begin
try
xmsg := 'Starting Watermarking process...';
result := false;
 LoadImage1(filetomark);
 { after multiple 'resizings' the watermark bitmap will get grainy, so load again for each image.  This is safe.  }
 LoadImage2WMK;
  { DONE -c121 :   Promote 8, 24 ....   ConvertToGray....    Resize.... }

  { DONE -c121 : PDF to JPG.... not automatically,  the logic determines what FileFormat to use.}
  { DONE -c121 : ConvertToGray....}
  { DONE -c121 : Resize....}
(*  WaterMarkConvertToGray;
    WaterMarkResizeRescind;
    MagIGManager.IGEffectsCtl.AddWatermark(vIGPage1,vIGPage2);
*)

////////////////////////  from watermark1   ////////


{note:  ExtractFileExt(filename);   the result contains the '.'  i.e. ".pdf"}

              { TODO -c121 : (not urgent, only create, if not already created.
                             and/or destroy when done.    DOES Accusoft IGFormatsCtrl have a DestroyObject ? }
  FIoLocation := MagIGManager.IGFormatsCtrl.CreateObject(IG_FORMATS_OBJ_IOFILE) As IIGIOLocation;
  (FIoLocation As IGIOFile).Filename := filetomark;
 pImageFormat :=  MagIGManager.IGFormatsCtrl.DetectImageFormat(FioLocation);
// MagIGmanager.IGFormatsCtrl.des...
//FIoLocation._Release;
 pintegerformat := pImageFormat;
//na msg1('Image format: ' + inttostr(pImageFormat) + GetIGFormatName(pImageFormat)  );

(* //na    if pImageFormat =  IG_FORMAT_PDF  then   msg1('pImageFormat : IG_FORMAT_PDF')
    else if pImageFormat =  IG_FORMAT_TIF   then   msg1('pImageFormat : IG_FORMAT_TIF ')
     else   if pImageFormat =  IG_FORMAT_JPG   then   msg1('pImageFormat : IG_FORMAT_JPG')
        else   if pImageFormat =  IG_FORMAT_POSTSCRIPT   then   msg1('pImageFormat : IG_FORMAT_POSTSCRIPT ')

       else msg1('unknown format')    ; *)

   PgInfo := MagIGManager.IGFormatsCtrl.GetPageInfo(FIoLocation, 0, IG_FORMAT_UNKNOWN);
   pgct := MagIGManager.IGFormatsCtrl.GetPageCount(FIoLocation,IG_FORMAT_UNKNOWN);
//na   scrollInit1(pgct);

(*  msg1('loading Page From File ' + filename);
  msg1('size: ' + Inttostr((Getfilesize(filename) Div 1024) + 1) + ' KB');
  msg1('pages :   ' + inttostr(pgct) + ' Pages.');
  msg1('bitdepth ' + inttostr(pginfo.BitDepth));
  msg1('compression ' + inttostr(pginfo.Compression));
  msg1('format ' + inttostr(pginfo.Format));
*)
//  h := vIGPage1.ImageHeight;
//  w := vIGPage1.ImageWidth;
//na  msg1('Resizing vIGPage2 (watermark).');
//moved below, for each page    MagIGManager.IGProcessingCtrl.ResizeImage(vIGPage2, w,h,IG_INTERPOLATION_GRAYSCALE);  //this is the Watermark.


{before we start the Multipage process, we need to get the filename, and delete any existing files of that name.}
           case pIntegerFormat  of
           IG_FORMAT_PDF, IG_FORMAT_TIF, IG_FORMAT_JPG,IG_FORMAT_EXIF_JPEG  :
               begin
                WMKFilename := GetWaterMarkFileName(filetomark);
               end;
            ELSE
               begin
                WMKFilename := GetWaterMarkFileName(filetomark,'.tif');
               end;
            end;
 NewFileName := WMKFilename;

for pg := 0 to pgct-1 do
     begin
     MagIGManager.IGFormatsCtrl.LoadPageFromFile(vIGPage1, filetomark, pg); //dialogLoadOptions.PageNum);
//na     vIGPageViewCtl1.UpdateView;
//na     msg1('Loaded page '+ inttostr(pg) + '  of  ' + inttostr(pgct-1));

     //if this is pdf, then we rasterize the IGPage, Convert to Gray, then watermark. then

     if pImageformat = IG_FORMAT_PDF then
       begin
//na       msg1('...PDF Rasterizing');
       VIGPage1.Rasterize;
//na       msg1('...PDF ConvertToGray');
       {/gek.   Without ConverttoGray,  a PDF color image, when Watermarked, has 'colored' Rescind, and inverted colors.
                and the 'RESCIND' isn't always easily visible.  Convert to gray, then watermark is viewable.
                ....  and we won't have JPG Advance Directives.  So this won't be an issue for 'RESCIND' watermark.  Maybe
                other watermarks in future need to revisit this issue. }
       MagIGManager.IGProcessingCtrl.ConvertToGray(vIGPage1);
       end
     else
     begin
      case pginfo.BitDepth of
      1:  begin
            //na  msg1('...bit depth 1 or 4,  ConvertToGray');
             MagIGManager.IGProcessingCtrl.ConvertToGray(vIGPage1);
          end;
      4:  begin
            //na msg1('...bit depth 1 or 4,  ConvertToGray');
            MagIGManager.IGProcessingCtrl.ConvertToGray(vIGPage1);
          end;
      8:  begin
            {was only converting TIF's to gray, if they weren't gray already.  Testing showed
              no need for this, converting all 8 bit worked okay., less complex.}
            //nc/  if pImageformat <> IG_FORMAT_TIF then
            //nc/       MagIGManager1.IGProcessingCtrl.ConvertToGray(vIGPage1);
            //nc/  else {format = IG_FORMAT_TIF}
            //nc/  if not vIGPage1.ImageIsGray then
            MagIGManager.IGProcessingCtrl.ConvertToGray(vIGPage1);
          end;
      10:  begin
             {We shouldn't have any Advance Directives 10 bit}
             {performing Watermark on 10,12,16  .. the invert changes pixels to white
               image looks washed out. Later Patch look into this for 10,12,16}
            MagIGManager.IGProcessingCtrl.Promote(vIGPage1,IG_PROMOTE_TO_24);
          end;
      12:  begin
               {even if Gray and 12,  the Watermark inverts and destroys the visible Image.
                     By Promoting,  then watermarking, the image is visible with watermark in inverted colors. }
            MagIGManager.IGProcessingCtrl.Promote(vIGPage1,IG_PROMOTE_TO_24);
          end;
      16:  begin
            MagIGManager.IGProcessingCtrl.Promote(vIGPage1,IG_PROMOTE_TO_24);
          end;
      24:  begin
              { do nothing, the convert to Gray is a possibility, for now, No.}
            // MagIGManager1.IGProcessingCtrl.ConvertToGray(vIGPage1);
          end;
      else  begin
              { do nothing, the convert to Gray is a possibility, for now, No.}
             // MagIGManager1.IGProcessingCtrl.ConvertToGray(vIGPage1);
          end;
      end; {case}
      end;
       {each page of a PDF can be different size}
         h := vIGPage1.ImageHeight;
         w := vIGPage1.ImageWidth;
       MagIGManager.IGProcessingCtrl.ResizeImage(vIGPage2, w,h,IG_INTERPOLATION_GRAYSCALE);  //this is the Watermark.



//na   msg1('...adding watermark');
   MagIGManager.IGEffectsCtl.AddWatermark(vIGPage1,vIGPage2);
(* ONE of these RadioButtons has to be checked in the Test App, so there is no ELSE (except in the rbSaveSame) rbSaveSame is what OCX will have*)
     if true  //rbSaveSAME.Checked
         then
          begin
          {save same is deceptive, because we promote 1 bit to 8 bit, and if 'Same' format (and compression)
             a ONE BIT 6 Page TIF goes from 308 KB to  48M !!!!!!!!!!!!!!!!!!!!    so we NEED  to use compression !!!!!!!!!}
           ///msg1('SavePageToFile  Append,  APPEND, UNKNOWN ');                                     // this will save as existing file type
           ///MagIGManager1.IGFormatsCtrl.SavePageToFile(vIGPage1,edtSaveAs.Text + FileExt,pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_UNKNOWN)
           case pIntegerFormat  of
           IG_FORMAT_PDF  :
              begin                                                            //IG_SAVE_PDF_JPG    //IG_SAVE_PDF_RLE
              MagIGManager.IGFormatsCtrl.SavePageToFile(vIGPage1,WMKFilename,pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_PDF_JPG);
              end;
           IG_FORMAT_TIF :
              begin
              MagIGManager.IGFormatsCtrl.SavePageToFile(vIGPage1,WMKFilename,pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_TIF_PACKED);
              end;
           IG_FORMAT_JPG :
               begin
              // MagIGManager.IGFormatsCtrl.SavePageToFile(vIGPage1,edtSaveAs.Text + '.JPG',pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_JPG);
               MagIGManager.IGFormatsCtrl.SavePageToFile(vIGPage1,WMKFilename,pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_JPG);
               end;
           IG_FORMAT_EXIF_JPEG :
               begin
               MagIGManager.IGFormatsCtrl.SavePageToFile(vIGPage1,WMKFilename,pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_JPG);
               end;
            ELSE
               begin
               MagIGManager.IGFormatsCtrl.SavePageToFile(vIGPage1,WMKFilename,pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_TIF_PACKED);
               end;
           end; {case}
          end;
(* na    if rbSaveTIF.Checked then
         begin
            msg1('SavePageToFile  Append,  APPEND, IG_SAVE_TIF_PACKED');
           MagIGManager1.IGFormatsCtrl.SavePageToFile(vIGPage1,edtSaveAs.Text + '.TIF',pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_TIF_PACKED);
          end;
    if rbSavePDF.Checked then
         begin
            msg1('SavePageToFile  Append,  APPEND, IG_SAVE_PDF_JPG');
           MagIGManager1.IGFormatsCtrl.SavePageToFile(vIGPage1,edtSaveAs.Text + '.PDF',pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_PDF_JPG);
          end;
    *)
  (* RLE not used.  issues when testing in Watermark1
      if rbSavePDFRLE.Checked then
         begin
            msg1('SavePageToFile  Append,  APPEND, IG_SAVE_PDF_JPG');
           MagIGManager1.IGFormatsCtrl.SavePageToFile(vIGPage1,edtSaveAs.Text + '.PDF',pg,IG_PAGESAVEMODE_APPEND,IG_SAVE_PDF_RLE);
          end;*)

     end;



/////////////////////////////
 // MOVED ABOVE in loop for pages.   NewFileName := GetWaterMarkFileName(filetomark);
// not here, now done in multipage loop.    SaveImage1(Newfilename);
result := true;

except
   on E:Exception do
      begin
      result := false;
      xmsg := e.Message;
      if NewFileName <> '' then copythefile(rmsg,GetWaterMarkBitmap,NewFileName,false);
      xmsg := xmsg + ' ' + rmsg;
      end;
end;
  //
end;


function TMagimport.GetWaterMarkFileName(filename : string; fileext : string=''): string;
var
vname, vSaveAs : string;
begin
if fileext <> ''  then filename := ChangeFileExt(filename,fileext);

vname :=  'WMK_' + ExtractFilename(filename);
vSaveAs := FdirTemp + vname ;

if FileExists(vSaveAs) then deleteFile(vSaveAs);
if FileExists(vSaveAs)
   then
   begin
   self.LogTheMsg('FAILED to clear file: ' + vSaveAs + ' ' + SysErrorMessage(Getlasterror));
   result := '';
   exit;
   end;
result := vSaveAs;


(*var
vPath, vname, vExt, vSaveAs : string;
begin

vPath :=ExtractFilePath(filename);
vname := 'WMK_' + ExtractFilename(filename);
vExt := extractFileExt(filename);

vSaveAs := vPath +  changefileext(vname,'.jpg');
result := vSaveAs; *)
end;


Function TMagImport.SetIAPIDirectories( Var Rmsg: String): Boolean;
var BaseDir: String;
vAppPath : string;
vAppDataFolder : string;
vIAPIFolder : string;
Begin
  try
  Result := True;
  vAppPath := Copy(ExtractFilePath(Application.ExeName), 1,  Length(ExtractFilePath(Application.ExeName)) - 1);
  vAppDataFolder := GetEnvironmentVariable('AppData');
  If vAppDataFolder <> ''
    then vIAPIFolder := vAppDataFolder + '\VistA\Imaging\'
    else vIAPIFolder := vAppPath + '\VistA\Imaging\' ;

  FDirTemp := vIAPIFolder + 'temp\';
  FDirImage := vIAPIFolder + 'image\';
  FDirCache := vIAPIFolder + 'cache\';
  FDirImport := vIAPIFolder + 'import\';
    Try
      If Not Directoryexists(FDirTemp) Then Forcedirectories(FDirTemp);
      If Not Directoryexists(FDirImage) Then Forcedirectories(FDirImage);
      If Not Directoryexists(FDirCache) Then Forcedirectories(FDirCache);
      If Not Directoryexists(FDirImport) Then Forcedirectories(FDirImport);
    Except
      Rmsg := 'Error creating Directories: ' + SysErrorMessage(Getlasterror);
      Result := False;
    End;

  except
  on E:exception do
    begin
    result := false;
    rmsg := e.message;
    end;
  end;
End;


procedure TMagImport.WaterMarkConvertToGray;
begin
  MagIGManager.IGProcessingCtrl.ConvertToGray(vIGPage1); //

end;


procedure TMagImport.WaterMarkResizeRescind;
var h,w : integer;
ioloc : IIGiolocation;
begin


//   ioloc := IGFormatsCtl1.CreateObject(IG_FORMATS_OBJ_IOFILE) As IIGIOLocation;
//        (ioloc As IGIOFile).FileName :=  image;//   dialogLoadOptions.FileName;
//  IGFormatsCtl1.GetPageCount(FglioLocation,IG_FORMAT_UNKNOWN);

  h := vIGPage1.ImageHeight;
  w := vIGPage1.ImageWidth;


MagIGManager.IGProcessingCtrl.ResizeImage(vIGPage2, w,h,IG_INTERPOLATION_GRAYSCALE);

end;




//
  //
    //
      //
        //



procedure TMagImport.CreateNewlog;
begin
  FLogList.clear
  //FLogList.add(FormatDateTime('hh:mm ', now) + 'Start Session.');
end;


procedure TMagImport.LogTheMsg(s: String);
begin
  FLogList.Add(s)
end;


function TMagImport.RPPatientHasPhoto(DFN: String; var Stat: Boolean; var FMsg: String): String;
begin
  Result := FDBBroker.RPPatientHasPhoto(DFN, Stat, FMsg);
end;

procedure TMagImport.LogTheList(t: Tstringlist);
var
  I: integer;
begin
  for I := 0 to t.Count - 1 do
  begin
    LogTheMsg(t[I])
  end;
end;


procedure TMagImport.LogTheList(t: Tstrings);
var
  I: integer;
begin
  for I := 0 to t.Count - 1 do
  begin
    LogTheMsg(t[I])
  end;
end;


function TMagImport.ImageArrayToFields(var xmsg: String; imgarray: Tstringlist) :
boolean;
var
  I: integer;
  fld,
  data: string;
// TEMPORARILY WE WILL PUT THE Acqs;Acql TOGETHER TO FORM ACQS
begin
  ClearProperties;
  Result := true;
  xmsg := '1^Image Array to Component fields. OK.';
  for I := 0 to imgarray.Count - 1 do
  begin
    try
      fld := FMagUtils.magpiece(imgarray[I], '^', 1);
      data := copy(imgarray[I], pos('^', imgarray[I]) + 1, 999);
      //data := FMagUtils.magpiece(imgarray[i], '^', 2);
      //if (FMagUtils.magpiece(imgarray[i], '^', 3) <> '') then data := data + '^' + FMagUtils.magpiece(imgarray[i], '^', 3);
      if fld='IMAGE' then
      begin
        FImages.Add(data)
      end;
      if fld='101' then
      begin
        SetAcqLoc(data)
      end;
      //ACQL
      if fld='.05' then
      begin
        SetAcqSite(data)
      end;
      //ACQS
      if fld='5' then
      begin
        SetDFN(data)
      end;
      if fld='16' then
      begin
        SetProcPKG(data)
      end;
      if fld='17' then
      begin
        SetProcIEN(data)
      end;
      if fld='15' then
      begin
        SetProcDt(data)
      end;
      if fld='108' then
      begin
        SetTrkNum(data)
      end;
      if fld='ACQD' then
      begin
        SetAcqDev(data)
      end;
      if fld='107' then
      begin
        SetAcqDev(data)
      end;
      if fld='ACQL' then
      begin
        SetAcqLoc(data)
      end;
      if fld='101' then
      begin
        SetAcqLoc(data)
      end;
      if fld='ACQS' then
      begin
        SetAcqSite(data)
      end;
      if fld='.05' then
      begin
        SetAcqSite(data)
      end;
      if fld='STATUSCB' then
      begin
        SetExcpHandler(data)
      end;
      { The next fields are NOT Required}
      if fld='ITYPE' then
      begin
        SetImgType(data)
      end;
      (*if (FImgType <> '')
    then
      begin
       // t.add(ResolveImageType);
      end;
    { TODO -ogarrett -cFields : create Function ResloveImageType }
    *)
      if fld='CALLMTH' then
      begin
        SetMethod(data)
      end;
      if fld='8' then
      begin
        SetCapBy(data)
      end;
      if fld='USERNAME' then
      begin
        SetUsername(data)
      end;
      if fld='PASSWORD' then
      begin
        SetPassword(data)
      end;
      if fld='10' then
      begin
        SetGroupDesc(data)
      end;
      if fld='DELFLAG' then
      begin
        SetDeleteFlag(magstrtobool(data))
      end;
      if fld='TRNSTYP' then
      begin
        SetTransType(data)
      end;
      if fld='100' then
      begin
        SetDOCCTG(data)
      end;
      if fld='110' then
      begin
        SetDocDt(data)
      end;
      { This is end of Fields that are sent as parameters }
      // FProcType
      // FProcDesc
      if fld='7' then
      begin
        SetCapDt(data)
      end;
      if fld='IEN' then
      begin
        SetGroupIEN(data)
      end;
      if fld='42' then
      begin
        SetIndexType(data)
      end;
      if fld='43' then
      begin
        SetIndexProc(data)
      end;
      if fld='44' then
      begin
        SetIndexSpec(data)
      end;
      if fld='45' then
      begin
        SetIndexOrigin(data)
      end

    { TODO : Have to account for ANY Image Field NUMBER.  here }
    // FGroupLongDesc not validated, it is sent as is ( if it exists)
    except
      on E : Exception do
        begin
          LogTheMsg(E.Message);
          xmsg := '0^Invalid Data.';
          Result := FALSE
        end;
    end;
  end;
  { DONE : ACQSite used to be Site;HospLOC, we now have two fields. ACQS and ACQL }
end;


procedure TMagImport.SetDFN(const Value: String);
begin
  FDFN := Value
end;


procedure TMagImport.SetImages(const Value: Tstrings);
var
  I: integer;
begin
  for I := 0 to Value.Count - 1 do
  begin
    if Value[I]='' then
    begin
      continue
    end;
    if Value[I]=' ' then
    begin
      continue
    end;
  end;
  FImages.assign(Value)
end;


procedure TMagImport.SetProcPKG(const Value: String);
begin
  FProcPKG := Value;
end;


procedure TMagImport.SetProcIEN(const Value: String);
begin
  FProcIEN := Value;
end;


procedure TMagImport.SetProcNew(const Value: String);
begin
  FProcNew := Value;
end;

procedure TMagImport.SetProcDt(const Value: String);
begin
  FProcDt := Value;
end;


procedure TMagImport.SetTrkNum(const Value: String);
begin
  if not DelimitedParam(Value) then
  begin
    raise EInvalidData.Create('Invalid format for Tracking ID: ' + Value)
  end;
  FTrkNum := Value
end;


procedure TMagImport.SetAcqDev(const Value: String);
begin
  FAcqDev := Value
end;


procedure TMagImport.SetAcqSite(const Value: String);
begin
  FAcqSite := Value
end;


procedure TMagImport.SetExcpHandler(const Value: String);
begin
  FExcpHandler := Value
end;


{ the Above are documented as required in the "M" API Call' }
procedure TMagImport.SetImgType(const Value: String);
begin
  FImgType := Value
end;


procedure TMagImport.SetMethod(const Value: String);
begin
  FMethod := Value
end;


procedure TMagImport.SetCapBy(const Value: String);
begin
  if ((Value<>'') and (not ValidInteger(Value))) then
  begin
    raise EInvalidData.Create('Invalid format for DUZ: ' + Value)
  end;
  FCapBy := Value
end;


procedure TMagImport.SetGroupDesc(const Value: String);
begin
  FGroupDesc := Value
end;


procedure TMagImport.SetDeleteFlag(const Value: boolean);
begin
  FDeleteFlag := Value
end;


procedure TMagImport.SetTransType(const Value: String);
begin
  { Possible values are  NEW.   Later we may implement MOD or DEL{}
  FTransType := Value
end;


{ The fields below aren't in the Parameters passed .. Yet}
procedure TMagImport.SetProcTIUSignatureType(const Value: String);
begin
  FProcTIUSignatureType := Value;
end;

procedure TMagImport.SetProcTIUText(const Value: TStrings);
begin
  FProcTIUText.Assign(Value);
end;

procedure TMagImport.SetProcTIUTitle(const Value: String);
begin
  FProcTIUTitle := Value;
end;

procedure TMagImport.SetProcType(const Value: String);
begin
  FProcType := Value
end;


procedure TMagImport.SetProcDesc(const Value: String);
begin
  FProcDesc := Value
end;


procedure TMagImport.SetCapDt(const Value: String);
begin
  FCapDt := Value
end;


procedure TMagImport.SetGroupIEN(const Value: String);
begin
  FGroupIEN := Value
end;


procedure TMagImport.SetGroupLongDesc(const Value: Tstrings);
begin
  FGroupLongDesc.assign(Value)
end;


procedure TMagImport.SetBroker(const Value: TRPCBroker);
begin
  FBroker := Value
end;


function TMagImport.GetDeleteFlag : boolean;
begin
  Result := FDeleteFlag
end;


function TMagImport.GetTransType : String;
begin
  Result := FTransType
end;


function TMagImport.GetGroupIEN : String;
begin
  Result := FGroupIEN
end;


function TMagImport.GetAcqDev : String;
begin
  Result := FAcqDev
end;


function TMagImport.GetAcqSite : String;
begin
  Result := FAcqSite
end;


function TMagImport.GetBroker : TRPCBroker;
begin
  Result := FBroker
end;


function TMagImport.GetCapBy : String;
begin
  Result := FCapBy
end;


function TMagImport.GetCapDt : String;
begin
  Result := FCapDt
end;


function TMagImport.GetDFN : String;
begin
  Result := FDFN
end;


function TMagImport.GetImages : Tstrings;
begin
  Result := FImages
end;


function TMagImport.GetImgType : String;
begin
  Result := FImgType
end;


function TMagImport.GetMethod : String;
begin
  Result := FMethod
end;




function TMagImport.GetProcDesc : String;
begin
  Result := FProcDesc
end;


function TMagImport.GetProcDt : String;
begin
  Result := FProcDt
end;


function TMagImport.GetProcPKG : String;
begin
  Result := FProcPKG
end;


function TMagImport.GetProcIEN : String;
begin
  Result := FProcIEN
end;


function TMagImport.GetProcNew: String;
begin
  Result := FProcNew;
end;

//function TMagImport.GetProcTIUSignature: String;
//begin
//  Result := FProcTIUSignature;
//end;

function TMagImport.GetProcTIUSignatureType: String;
begin
  Result := FProcTIUSignatureType;
end;

function TMagImport.GetProcTIUText: TStrings;
begin
  Result := FProcTIUText;
end;

function TMagImport.GetProcTIUTitle: String;
begin
  Result := FProcTIUTitle;
end;

function TMagImport.GetProcType : String;
begin
  Result := FProcType;
end;


function TMagImport.GetTrkNum : String;
begin
  Result := FTrkNum
end;


function TMagImport.GetExcpHandler : String;
begin
  Result := FExcpHandler
end;


function TMagImport.GetGroupDesc : String;
begin
  Result := FGroupDesc
end;


function TMagImport.GetGroupLongDesc : Tstrings;
begin
  Result := FGroupLongDesc
end;


function TMagImport.GetMag4Security : TMag4Security;
begin
  Result := FMagSecurity
end;


procedure TMagImport.SetMag4Security(const Value: TMag4Security);
begin
  FMagSecurity := Value
end;


function TMagImport.CopyImageToServer(var xmsg: String; imageID, imagefile: String) : boolean;
var
  nFullName,
  oFullName: string;
begin
  try
    LogDebugMsg('CP-1 CopyImageToServer: imageID='+imageID);
    LogDebugMsg('CP-1 CopyImageToServer: imagefile='+imagefile);
    nFullName := FMagUtils.magpiece(imageID, '^', 2) + FMagUtils.magpiece(imageID, '^', 3);
    oFullName := imagefile;
    //fUnStrings.Add(Inttostr(Funstrings.count)); // force error
    if CopyTheFile(xmsg, oFullName, nFullName)
      then
        result := true
      else
        result := false;
  except
  on E:Exception do
   begin
   Result := false;
   xmsg := '0^'+e.message;
   end;
  end;
end;


function TMagImport.CopyTheFile(var xmsg: String; FromFile, ToFile: String; MakeTXT : boolean = true) : boolean;
var
  ndir: string;
  tmpUser,
  tmpPass,
  zmsg,
  textmsg: string;
begin
  tmpUser := '';
  tmpPass := '';
  xmsg := 'Start Copying File...';
  Result := FALSE;
  { Here we copy the File to the Image Write Directory ( Image Network Server )}
  try
    { Quit if we can't connect to the Image Network Server }
    if ((FUsername<>'') and (FPassword<>'')) then
    begin
      try

       tmpUser := FUsername   ;
       tmpPass := decrypt(FPassword);      //p121 VLER gek uncomment this line.

      except
        on E : Exception do
          begin
            xmsg := '-1^Error: Invalid Password.';
            FMagSecurity.MagCloseSecurity(zmsg);
            exit
          end;
      end;
    end;
    { TODO : Passed Username and Password is for FROM directory }
    LogDebugMsg('CP-2 Attempting OpenSecurePath: FromFile='+FromFile);
    LogDebugMsg('CP-2 Attempting OpenSecurePath: tmpUser='+tmpUser);
    LogDebugMsg('CP-2 Attempting OpenSecurePath: tmpPass='+tmpPass);
    if not FMagSecurity.MagOpenSecurePath(FromFile, xmsg, tmpUser, tmpPass) then
    begin
      LogDebugMsg('CP-2 Attempt Failed. ');
      Floglist.AddStrings(FMagSecurity.msglist);
      exit
    end;
      LogDebugMsg('CP-2 Attempt Success. ');
    { DONE : Test if File Exists : }
    if not FileExists(FromFile) then
    begin
      LogDebugMsg('CP-2 File doesn''t exist : FromFile:  '+ FromFile);
      xmsg := 'File doesn''t exist : ' + FromFile;
      exit
    end;
    try
    LogDebugMsg('CP-2 Attempting OpenSecurePath: ToFile='+ToFile);
    LogDebugMsg('CP-2 Attempting OpenSecurePath: tmpUser was never sent.');
    LogDebugMsg('CP-2 Attempting OpenSecurePath: tmpPass was never sent.');
    if not FMagSecurity.MagOpenSecurePath(ToFile, xmsg, '', '', true) then
    begin
    LogDebugMsg('CP-2 Attempt at OpenSecurePath: FAILED');
      //FLogList.AddStrings(FMagSecurity.msglist);
      result := false;
      exit
    end;
    except
    on E:exception do
      begin
        result := false;
        xmsg := '0^Error during Open Network Connection';
        LogtheMsg(e.message);
      end;
    end;
    { Quit if we need to create the directory, but can't.
                             ( mainly for Hashed Directories )}
    if not DIRECTORYEXISTS(ExtractFileDir(ToFile)) then
    begin
    LogDebugMsg('CP-2 Attempting to Create Directory : ' + ToFile);
      ndir := ExtractFileDir(ToFile);
      forcedirectories(ndir);
      if not DIRECTORYEXISTS(ndir) then
      begin
        LogDebugMsg('CP-2 Attempting to Create Directory Failed: ' + ToFile);
        xmsg := '0^Can''t create directory: ' + ExtractFileDir(ToFile);
        exit
      end;
    end;
    try
        LogDebugMsg('CP-2 Attempting to "CopyFile" :  fromFile: ' + FromFile);
        LogDebugMsg('CP-2 Attempting to "CopyFile" :    ToFile: ' + ToFile);
      // THIS Is the windows Call :
      if Copyfile(pchar(FromFile), pchar(ToFile), true) then
      begin
        LogDebugMsg('CP-2 Attempting to "CopyFile" :   SUCCESS');
        Result := true;
        // CPMOD  make the text file.
       LogDebugMsg('CP-2 CreateAndSaveImageTextFile');
       if MakeTXT then  CreateAndSaveImageTextFile(ToFile, textmsg); // etrap ok
      end
      else
      begin
        LogDebugMsg('CP-2 Attempt to "CopyFile" :  FAILED ');
        logDebugMsg('CP-2 Attempt to "CopyFile" GetLastError: ' + SysErrorMessage(Getlasterror));
        Result := FALSE;
        xmsg := '0^FAILED to Copy File: ' + FromFile + ' to: ' + ToFile
      end;
      { TODO : Test for existance and Size > 0 }
      FMagSecurity.MagCloseSecurity(zmsg) ;

    except
      on E : Exception do
        begin
          xmsg := '0^' + E.Message;
          FMagSecurity.MagCloseSecurity(zmsg)
        end;
    end;
  logDEbugMsg('CP-2 Logging the MagSecurity List');
  logDEbugMsg(Fmagsecurity.Msglist); // in for debug
                                             
  except
   on E: exception do
    begin
      xmsg := '0^Exception -  during CopyTheFile function';
      LogTheMsg(e.message);
    end;
  end;
end;


procedure TMagImport.FileSpecialtyPointers(imageID: String);
var
  magien: string;
begin
  { Were only doing TIU documents for now, so this code will have to be
     modified later to enable importing images via this API to other packages.{}
  magien := FMagUtils.magpiece(imageID, '^', 1);
  if (UPPERCASE(FProcPKG)='TIU')
      or
     (FProcPKG='8925') then
  begin
    if (FProcIEN='') then
    begin
      LogDebugMsg('3- FileSpecPointers:  Procedure IEN is Null.');
      exit
    end;
    FDBBroker.RPMag3TIUImage(Fstat, Flist, magien, FProcIEN);
    if not Fstat then
    begin
      LogDebugMsg('3- FileSpecialtyPointers Failed');
      LogDebugMsg('3- ImageIEN: ' + magien + 'TIU DA: ' + FProcIEN);
      LogDebugMsg('3- ' + Flist[0]);
      LogTheList(Flist);
    end
    else
      begin
       LogDebugMsg('3- FileSpecialtyPointers OK.');
       LogDebugMsg('3- Image IEN: '+magien+ 'Procedure IEN: '+ Fprocien);
     end;
  end;
end;


{ VistAInit assures we can connect, and get UserName password from Site.{}
procedure TMagImport.IndexEventList(var slEvent: TStringList;
                                    ClassChoice: String = '';
                                    SpecChoice: String = '';
                                    ignoreStatus: Boolean = False;
                                    incClass : Boolean = False;
                                    incStatus : Boolean = False);
begin
  slEvent.Clear;
  FDBBroker.RPIndexGetEvent(slEvent, ClassChoice, SpecChoice,
                            ignoreStatus, incClass, incStatus);
end;

procedure TMagImport.IndexOriginList(var slOrigin: TStringList);
begin
  slOrigin.Clear;
  FDBBroker.RPIndexGetOrigin(slOrigin);
end;

procedure TMagImport.IndexSpecSubSpecList(var slSubSpec: TStringList;
                                          ClassChoice: String = '';
                                          ProcsChoice: String = '';
                                          ignoreStatus: Boolean = False;
                                          incClass: Boolean = False;
                                          incStatus: Boolean = False;
                                          incSpec: Boolean = False);
begin
  slSubSpec.Clear;
  FDBBroker.RPIndexGetSpecSubSpec(slSubSpec, ClassChoice, ProcsChoice,
                                  ignoreStatus, incClass, incStatus, incSpec);
end;

procedure TMagImport.IndexTypeList(var slType: TStringList;
                                   ClassChoice: String = '';
                                   IgnoreStatus: Boolean = False;
                                   incClass: Boolean = False;
                                   incStatus: Boolean = False);
begin
  slType.Clear;
  FDBBroker.RPIndexGetType(slType, ClassChoice, IgnoreStatus, incClass, incStatus);
end;

procedure TMagImport.InitIfNeeded;
var  toInt : integer;
toStr : string;
 ini : Tinifile;
begin
  if not assigned(FDBBroker) then
  begin
    FDBBroker := TMagDBMVista.Create();
  end;
  if not assigned(FBroker) then
  begin
    FBroker := TRPCBroker.Create(Self)
  end;
  FDBBroker.SetBroker(FBroker);
  {p121 debug}
  FApplicationPath := ExtractFilePath(application.ExeName);
  ini := Tinifile.Create(FApplicationpath+'MagimportX.ini');
  tostr := ini.ReadString('broker','timeout','0');
  toint := strtoint(toStr);
  if toint > 0 then FBroker.RPCTimeLimit := toInt;
   {p121 debug}


  toInt := Fbroker.RPCTimeLimit ;
  LogDebugMsg('RPCTimeLimit: ' + inttostr(toInt));    //121 debug msg POR error
  // .broker := FBroker;
  if not assigned(FMagSecurity) then
  begin
    FMagSecurity := TMag4Security.Create(Self)
  end;

  FBroker.OnPulseError := IAPIOnPulseError;
end;


procedure TMagImport.ConnectIfNeeded(var vserver: String; var vport: String;
                                     accesscode: String = '';
                                     verifycode: String = '';
                                     division : string = '');
begin
  InitIfNeeded;
  if FSALastLogon then
  begin
    vserver := FSAvserver ;
    vport := FSAvport ;
    accesscode := FSAaccesscode ;
    verifycode := FSAverifycode ;
    division := FSAdivision ;
  end;

  if not FDBBroker.IsConnected then
  begin
    if (vserver='')
        or
       (vport='') then
    begin
      FDBBroker.DBSelect(vserver, vport, 'MAG WINDOWS')
    end
    else
    begin
      FDBBroker.DBConnect(vserver, vport, 'MAG WINDOWS', accesscode, verifycode,division) ;
      if FDBBroker.IsConnected then
        begin
            FSAvserver := vserver;
            FSAvport := vport;
            FSAaccesscode := accesscode;
            FSAverifycode := verifycode;
            FSAdivision := division;
            FSALastLogon := true;
         end;
    end;
  end;
end;


procedure TMagImport.VistAInit(var status: boolean;
                               var xmsg: String;
                               var vserver: String;
                               var vport: String;
                               accesscode: String = '';
                               verifycode: String = '';
                               division: String = '');
var
  DUZ,
  Username: string;
  rlist: TStrings;
  forceError : tstrings;
  forceerrorstring : string;
  rmsg: string;
{/p121 slFlag and division}
  slFlag: boolean;
  dbgmsg : string;

begin


{p121 debug.}
{$ifdef magdebug}
dbgmsg := 'Debug OCX messages :' +#13
        + 'xmsg: ' + xmsg + #13
        + 'vserver: ' + vserver + #13
        + 'vport: ' + vport + #13
        + 'accesscode: ' + accesscode + #13
        + 'verifycode: ' + verifycode + #13
        + 'division: ' + division ;
messagedlg(dbgmsg,mtconfirmation,[mbok],0);
{$endif}
//LogDebugMsg('VistaInit- RPCBroker TimeLimit: ' + inttostr(FBroker.RPCTimeLimit));

{p121 magdebug. end.}

  slflag := false;
  status := False;
  rlist := TStringlist.Create;
   {P121 HERE,  xmsg may have the extra data from OCX. Division.}
   if division <> ''  then
   begin
     slFlag := true;
     //division := xmsg;
     xmsg := '';

   end;
  try
    try
      ConnectIfNeeded(vserver, vport, accesscode, verifycode,division);
    except
      on E:Exception do
      begin
        xmsg := E.Message;
        Exit;
      end;
    end;

    if not FDBBroker.IsConnected then
    begin
      xmsg := 'No Connection to VISTA.';
      Exit;
    end;

    FDBBroker.RPMaggUser2(Fstat, rmsg, rlist, 'Import API');
    //try
    //forceerrorstring := forceerror[3];
    //except
    //  messagedlg('In Except Block for forced error.',mterror,[mbok],0);
    //end;
    if not Fstat then
    begin
      xmsg := rlist[0];
      Exit;
    end;

    DUZ := FMagUtils.magpiece(rlist[1], '^', 1);

    if not SetNetUsernamePassword(FMagUtils.magpiece(rlist[2],'^',1),
                                  FMagUtils.magpiece(rlist[2],'^',2),
                                  FMagSecurity,
                                  xmsg) then
    begin
      Exit;
    end;

    (*MagFileSecurity.Username := magpiece(xBrokerx.RESULTS[2],'^',1);
   MagFileSecurity.Password := decrypt(magpiece(xBrokerx.RESULTS[2],'^',2));*)
    if DUZ = '0' then
    begin
      status := False;
      xmsg := FMagUtils.magpiece(rlist[1], '^', 2) + ' Disconnecting from VistA';
      FBroker.Connected := False;
    end
    else
    begin
      status := True;
      Username := FMagUtils.magpiece(rlist[1], '^', 2);
      xmsg := Username + ': ' + vserver + ' connection OK. ';
      FCaptureKeys.Clear
    end;

  finally
    rlist.Free;
  end;
end;


{/p121}
function TMagImport.GetNetSecurityOn: boolean;
begin
try
//force error
{$ifdef magdebug}
    result := FMagSecurityNOTCreated.SecurityOn;
    exit;
 {$endif}

 result := false;
 if assigned(self.MagSecurity) then
   if self.MagSecurity <> nil then
      result := self.FMagSecurity.SecurityOn;
except
 on e:exception do
   begin
   showmessage('Exception cMagImport : GetNetSecurity - ' + e.Message);
   result := false
   end;
end;
end;

 {/p121}
procedure TMagImport.SetNetSecurityOn(const Value: boolean);
begin
try
  // force error.
{$ifdef magdebug}
    FMagSecurityNOTCreated.SecurityOn := value;
 {$endif}
   if assigned(self.MagSecurity) then
   if self.MagSecurity <> nil then self.MagSecurity.SecurityOn := value;
except
   // testing////

  on e:exception do showmessage('Exception cMagImport : SetNetSecurity - ' + e.Message);
end;
end;

function TMagImport.SetNetUsernamePassword(user, pass: String; var MagSec:
              TMag4Security; var xmsg: String) : boolean;
begin
  Result := FALSE;
  if (user='')
      or
     (pass='') then
  begin
    xmsg := '0^Invalid Imaging Network Username or Password.'
  end
  else
  begin
    try
      MagSec.Username := user;
      MagSec.Password := decrypt(pass);
      Result := true
    except
      on E : Exception do
        begin
          xmsg := '0^Error during password decryption.'
        end;
    end;
  end;
end;


procedure TMagImport.DeleteImageEntry(var xmsg: String; ien: String);
var
  s: string;
  rmsg: string;
  rlist: Tstrings;
begin
  rlist := Tstringlist.Create;
  try
    s := '';
    if (ien='') then
    begin
      exit
    end;
    FDBBroker.RPMaggImageDelete(Fstat, rmsg, rlist, ien, '1');
    xmsg := rlist[0];
    if not Fstat then
    begin
      LogTheList(rlist)
    end

  finally
    rlist.Free
  end;
end;


function TMagImport.GetDBBroker : TMagDBBroker;
begin
  Result := FDBBroker
end;


procedure TMagImport.SetDBBroker(const Value: TMagDBBroker);
begin
  FDBBroker := Value
end;


function TMagImport.GetAcqLoc : String;
begin
  Result := FAcqLoc
end;


function TMagImport.GetDOCCTG : String;
begin
  Result := FDOCCTG
end;


function TMagImport.GetDocDt : String;
begin
  Result := FDocDT
end;


function TMagImport.GetPassword : String;
begin
  Result := FPassword
end;


function TMagImport.GetUsername : String;
begin
  Result := FUsername
end;


procedure TMagImport.SetAcqLoc(const Value: String);
begin
  FAcqLoc := Value
end;


procedure TMagImport.SetDOCCTG(const Value: String);
begin
  FDOCCTG := Value
end;


procedure TMagImport.SetDocDt(const Value: String);
begin
  FDocDT := Value
end;


procedure TMagImport.SetPassword(const Value: String);
begin
  FPassword := Value
end;


procedure TMagImport.SetUsername(const Value: String);
begin
  FUsername := Value
end;


function TMagImport.CreateAndSaveImageTextFile(imageToFile: String; var xmsg: String) : boolean;
var
  imageTextfile: string;
  t,
  t1: Tstringlist;
  stat: boolean;
  patinfo: string;
begin
  Result := FALSE;
  xmsg := 'Attempting to save .txt file...';
  t := Tstringlist.Create;
  t1 := Tstringlist.Create;
  try
 {/p121 gek : fix future problem where multiple "."s in file name,  use ChangeExt function}
//    imageTextfile := FMagUtils.magpiece(imageToFile, '.', 1) + '.txt';
    imageTextfile := ChangeFileExt(imageToFile,'.txt');
    t.Add('$$BEGIN IMAGE DATA');
    t.Add('TRANSACTION_ID=' + FTrkNum);

    FDBBroker.RPMagPatInfo(stat, patinfo, FDFN);
    t.Add('PATIENTS_NAME=' + FMagUtils.magpiece(patinfo, '^',
                  3));
    //Pt Name );
    t.Add('PATIENTS_ID=' + FMagUtils.magpiece(patinfo, '^', 6));
    //Pt SSN );
    t.Add('PATIENTS_BIRTH_DATE=' + FMagUtils.magpiece(patinfo,
                    '^', 5));
    //Pt DOB );
    t.Add('PATIENTS_SEX=' + FMagUtils.magpiece(patinfo, '^',
                  4));
    // PT SEX );
    t.Add('IMAGE_DATE=' + CapDt);
    t.Add('CAPTURED BY=' + CapBy);
    t.Add('ACQ_DEVICE=' + FAcqDev);
    // t.Add('SHORT DESCRIPTION=' + (FMagUtils.magpiece(FMagUtils.magpiece(imageID,'|',2),'^',2)));    (*
    (*if imagelongdesc.lines.count > 0 then
    begin
      t.add('LONG DESCRIPTION');
      for i := 0 to imagelongdesc.lines.count - 1 do
      begin
        t.Add(imagelongdesc.lines[i]);
      end;
    end;   *)
    t.Add('$$END IMAGE DATA');
    try
      t.SaveToFile(imageTextfile);
      xmsg := 'Notes saved to .txt file: ' + imageTextfile;
      Result := true
    except
      xmsg := 'Failed to copy .txt File to Imaging Network';
      exit
    end;

  finally
    t.Free;
    t1.Free
  end;
end;


procedure TMagImport.SaveDirect(var status: boolean; var xmsglist: Tstrings);
var
  xmsg: string;
  vserver,
  vport: string;
  t: Tstringlist;
  relist: Tstringlist;
  stat: boolean;
begin
  //Maglogger.Log(Trace, 'Entered TMagImport.SaveDirect');

  VistAInit(stat, xmsg, vserver, vport);
  if not stat then
  begin
    status := stat;
    xmsglist.insert(0, xmsg);
    exit
  end;
  //  ConnectIfNeeded(vserver ,vport );
  if not FBroker.Connected then
  begin
    status := FALSE;
    xmsglist.insert(0, 'No Connection to VISTA');
    exit
  end;
  t := Tstringlist.Create;
  try
    relist := Tstringlist.Create;
    FLogList.clear;
    ImageArrayFromFields(t);
    // new
    t.Add('TRTYPE^NOQUEUE');
    stat := ImportDataArray(relist, t);
    // with transaction type = NOQUEUE, it'll do Req Field check
    //  and validate, then stop. without creating the queue.

    if stat then    
      //Maglogger.Log(Info, 'Stat = True')
    else
      //Maglogger.Log(Info, 'Stat = False');

    if not stat then
    begin
      status := stat;
      xmsglist.assign(relist);
      exit
    end;
    status := Save(xmsg);

    if ((FMagUtils.magpiece(xmsg, '^', 1)='1') and (FLogList.Count>
                                                                   0)) then
    begin
      xmsg := '2' + copy(xmsg, 2, 999)
    end;
    //^' + FMagUtils.magpiece(xmsg, '^', 2);
    FLogList.insert(0, xmsg);
    FLogList.insert(1, FTrkNum);
    xmsglist.assign(FLogList)
  finally
    // P8t32  Weren't we calling the Status Callback Routine.
    MagDBBroker.RPMag4StatusCallback(xmsglist, FExcpHandler);

    { TODO : take out the // testing }
    ClearProperties;
    t.Free;
    relist.Free;
    //Maglogger.Log(Trace, 'Exited TMagImport.SaveDirect');
  end;
end;


procedure TMagImport.IAPIOnPulseError(peBroker: TRPCBroker; peErr: string);
begin
FOnPulseErrorText := peErr;
//showmessage(' on Pulse Error:  ' + peErr);
{ We want to log the error... but not stop application with dialog box.
 the RPCBroker tried to call VistA with it's onPulseTimer, .. and had a problem.
  So we will now catch the error here.  This was one reason we were
  getting Access Violation, because if this error isn't handled,
  the code in trpcb.pas  shows the Exception in Dialog Box (i.e. the Access Violation) }

end;

procedure TMagImport.ImageAdd(imagefile: String);
begin
  Images.Add(imagefile)
end;


procedure TMagImport.showproperties;
var
  s: string;
begin
  s := '';
  s := s + ('IDFN: ' + FDFN) + ' [' + IntToStr(length(FDFN)) +
       ']' + #13#10;
  s := s + ('PXPKG: ' + FProcPKG) + ' [' + IntToStr(length(FProcPKG)) +
       ']' + #13#10;
  s := s + ('PXIEN: ' + FProcIEN) + ' [' + IntToStr(length(FProcIEN)) +
       ']' + #13#10;
  s := s + ('PXDT: ' + FProcDt) + ' [' + IntToStr(length(FProcDt)) +
       ']' + #13#10;
  s := s + ('TRKID: ' + FTrkNum) + ' [' + IntToStr(length(FTrkNum)) +
       ']' + #13#10;
  s := s + ('ACQD: ' + FAcqDev) + ' [' + IntToStr(length(FAcqDev)) +
       ']' + #13#10;
  s := s + ('ACQS: ' + FAcqSite) + ' [' + IntToStr(length(FAcqSite)) +
       ']' + #13#10;
  s := s + ('ACQL: ' + FAcqLoc) + ' [' + IntToStr(length(FAcqLoc)) +
       ']' + #13#10;
  s := s + ('STSCB: ' + FExcpHandler) + ' [' + IntToStr(length(FExcpHandler)) +
       ']' + #13#10;
  s := s + ('ITYPE: ' + FImgType) + ' [' + IntToStr(length(FImgType)) +
       ']' + #13#10;
  s := s + ('CDUZ: ' + FCapBy) + ' [' + IntToStr(length(FCapBy)) +
       ']' + #13#10;
  s := s + ('DOCCTG: ' + FDOCCTG) + ' [' + IntToStr(length(FDOCCTG)) +
       ']' + #13#10;
  s := s + ('DOCDT: ' + FDocDT) + ' [' + IntToStr(length(FDocDT)) +
       ']' + #13#10;

  s := s + ('IXTYPE: ' + FixType) + ' [' + IntToStr(length(FixType)) +
       ']' + #13#10;
  s := s + ('IXSPEC: ' + FixSpec) + ' [' + IntToStr(length(FixSpec)) +
       ']' + #13#10;
  s := s + ('IXPROC: ' + FixProc) + ' [' + IntToStr(length(FixProc)) +
       ']' + #13#10;
  s := s + ('IXORIGIN: ' + FixOrigin) + ' [' + IntToStr(length(FixOrigin)) +
       ']' + #13#10;

  s := s + ('GDESC: ' + FGroupDesc) + ' [' + IntToStr(length(FGroupDesc)) +
       ']' + #13#10;
  ShowMessage(s)
end;


procedure TMagImport.StayAliveTimer(Sender: TObject);
var rTimeout : string;
  dummystr : string;
  rInt : integer;
begin
///showmessage('in Stay Alive Timer Testing Patch 135');
LogDebugMsg('in Stay Alive Timer Testing Patch 135');
dummystr := 'dummy string';
FTimerStayAlive.Enabled := false;
StayAlive(true);
end;

function TMagImport.StayAlive(value : boolean): string;
var dummystr, rtimeout : string;
brkint: integer;

begin

try
brkint := FDBBroker.GetBroker.RPCTimeLimit;

if value then
  begin
    FTimerStayAlive.Enabled := false;
{135 t3  accesss violation is showing after job is killed, and we wait.... if we send another Import Queue, the
     connection is reestablished....  if not, we get OnPulseTimer Trpcb error.}
   if self.FSALastLogon
   then
   ConnectIfNeeded(FSAvserver, FSAvport, FSAaccesscode, FSAverifycode,FSAdivision);

    rtimeout := MagGetSystemTimeout(dummystr); // any call will do here.  It's resets the RPCBroker timer.

    if (FMagUtils.MagPiece(rtimeout,'^',1) = '0') then raise exception.Create(FMagUtils.magpiece(rtimeout,'^',2));

    FTimerStayAlive.Interval := (900 * brkint)  ; ///(9000) this was 9 secs for testing //    (900 * rint);
    result := '1^Interval set to : 90 % of ' + inttostr(brkint);
    FTimerStayAlive.Enabled := true;
     //bp xxxGetSystemTimeOut(TimeOut);
     //bp xxxif StrToInt(TimeOut)< 30 then TimeOut := '30';
     //bp xxxTimer2.Interval := (StrToInt(Timeout)*900);

   { MabBroker.RCPTimeLimit    from Help :
      The RPCTimeLimit property is a public integer property that is available at run-time only.
      It specifies the length of time a client will wait for a response from an RPC.
      The default and minimum value of this property is 30 seconds. If an RPC is expected
      to take more than 30 seconds to complete, adjust the RPCTimeLimit property accordingly.
      However, it is not advisable to have an RPCTimeLimit that is too long.
      Otherwise, the client-end of the application will appear to "hang",
      if the VistA M Server doesnt respond in a timely fashion. }
   (* MagBroker.RPCTimeLimit :=  rint; *)

  end
  else
  begin
    FTimerStayAlive.Enabled := false;
    result := '1^Stay Alive Timer:  Disabled' ;
  end;
except
   on e:exception do
     begin
     FTimerStayAlive.Enabled := false;
     result := '0^Exception in IAPI StayAlive: '+ e.message;
     end;
end;

end;


function TMagImport.MagGetSystemTimeout(data : string): string;
var rstr : string;
mstr: string;
rtimeout : string;
timeout9 : integer;
begin
TRY
{/p135   - data is a string passed from app.  Not sure what will or needs to be in it yet.}

mstr :=   '$G(^XTV(8989.3,1' + ',"XWB"))';
  if FDBBroker.IsConnected then
     begin

       MagBroker.RemoteProcedure := 'XWB GET VARIABLE VALUE';
       MagBroker.Param[0].Value := mstr ;
       MagBroker.Param[0].PType := reference;

       rstr := MagBroker.strCall;

       rtimeout := FMagUtils.MagPiece(rstr,'^',1);
       logDebugMsg('Mstr: ' + mstr + '   Result String: ' + rstr + '  piece 1: ' + rtimeout);
      {value in VistA is seconds.  We'll default to 5 mintes}
       if rtimeout = '' then rtimeout := '300';

        result := rtimeout;

     end;  {if connected}
EXCEPT
  ON E:exception do
     begin
       //
       result := '0^Exception: IAPI GetSystemTimeout:  ' + e.message;
     end;
END;  {try except}
end;



function TMagImport.GetIndexProc : String;
begin
  Result := FixProc
end;


function TMagImport.GetIndexSpec : String;
begin
  Result := FixSpec
end;


function TMagImport.GetIndexType : String;
begin
  Result := FixType
end;


function TMagImport.GetIndexOrigin : String;
begin
  Result := FixOrigin
end;


procedure TMagImport.SetIndexProc(const Value: String);
begin
  FixProc := Value
end;


procedure TMagImport.SetIndexSpec(const Value: String);
begin
  FixSpec := Value
end;


procedure TMagImport.SetIndexType(const Value: String);
begin
  FixType := Value
end;


procedure TMagImport.SetInsertProcTIUText(const Value: string);
begin

end;

procedure TMagImport.SetIndexOrigin(const Value: String);
begin
  FixOrigin := Value
end;


(*procedure TmagImport.LogFileInit;
var
   filex : string;
begin
  filex := ExtractFilePath(Application.ExeName)+ 'MagIAPI'+FormatDateTime('mmddyy', NOW)+'.log';
  AssignFile(FMyLogFile,filex);
  if not FileExists(filex)
    then ReWrite(FMyLogFile)
    else Append(FMyLogFile);
end;  *)
procedure TMagImport.LogDebugMsg(s: String);
begin
{$IFDEF magdebug}
    FLogList.Add(s)
{$ENDIF}
end;


procedure TMagImport.LogDebugMsg(t: Tstrings; pf : string = '');
var
  I: integer;
begin
{$IFDEF magdebug}
  if (pf <> '') then pf := pf + ' - ';
  for I := 0 to t.Count - 1 do
  begin
    LogTheMsg(pf+t[I])
  end;

{$ENDIF}
end;

function TMagImport.BoolToStr(val: boolean): string;
begin
if val then result := 'True'
  else result := 'False';
end;

end.
